(function ($) {
    'use strict';
    $(document).ready(function () {
        $('#user-manual').parent().attr('target','_blank');  
        $('#submit-a-ticket').parent().attr('target','_blank'); 
        $('.operator').change(function (e) {
            if ($(this).val() == ">" || $(this).val() == ">=") {
                $(".scope").children().each(function () {
                    if ($(this).val() == "additional_item") {
                        $(this).prop('disabled', false);
                    }
                });
            } else if ($(this).val() == "<" || $(this).val() == "<=" || $(this).val() == "==" || $(this).val() == "!=") {
                $(".scope").children().each(function () {
                    if ($(this).val() == "additional_item") {
                        $(this).prop('disabled', true);
                    }
                });
            }
        });
        //we delay the init to avoid conflicts with plugin that hook on the select2 classes and create conflicts
        setTimeout(function () {
            $("#font").select2({allowClear: true, placeholder: "Pick a google font"});
        }, 500);

        load_select2();

        function load_select2(container)
        {
            if (typeof container == "undefined")
                container = "";
            $(container + " select.o-select2").each(function () {
//                console.log($(this));
                $(this).select2({allowClear: true});
            });
        }

        // Gérer l'affichage des opérateurs
        function hideoption(group, rule, valeur) {
            var h = 0;
            $.each(operators, function () {
                var op = $('#csd-pricing-group_' + group + '_rule_' + rule + '_' + h).val();
                if (valeur === 'if_selected_font') {
                    if (op !== "==" && op !== "!=") {
                        $('option#csd-pricing-group_' + group + '_rule_' + rule + '_' + h).css('display', 'none');
                    }
                } else {
                    $('option#csd-pricing-group_' + group + '_rule_' + rule + '_' + h).css('display', 'block');
                }
                h++;
            });
        }

        /**
         * Function to automatically update the operators field
         */

        function csd_update_rule_operator(table_length, group_index, new_rule_index) {
            if (typeof (group_index) !== 'undefined' && typeof (new_rule_index) !== 'undefined') {
                var valeur = $('#csd-group_' + group_index + '_rule_' + new_rule_index + '_param   option:selected').val();
                hideoption(group_index, new_rule_index, valeur);
                $('#csd-group_' + group_index + '_rule_' + new_rule_index + '_param').change(function () {
                    valeur = $(this).val();
                    hideoption(group_index, new_rule_index, valeur);
                    $('#csd-pricing-group_' + group_index + '_rule_' + new_rule_index + '_operator option[style="display: block;"]').eq(0).prop("selected", true);
                });
            } else {
                var i = 0;
                while (i < table_length) {
                    var body_length = $('table.csd-rules-table.widefat tbody')[i].getElementsByTagName("tr").length;
                    var j = 0;
                    while (j < body_length) {
                        var valeur = $('#csd-group_' + i + '_rule_' + j + '_param   option:selected').val();
                        hideoption(i, j, valeur);
                        $('#csd-group_' + i + '_rule_' + j + '_param').change(function () {
                            var param_id = $(this).attr('id');
                            var par_tab = param_id.split('_');
                            var group = par_tab[1];
                            var rule = par_tab[3];
                            valeur = $(this).val();
                            hideoption(group, rule, valeur);
                            $('#csd-pricing-group_' + group + '_rule_' + rule + '_operator option[style="display: block;"]').eq(0).prop("selected", true);
                        });
                        j++;
                    }
                    i++;
                }
            }
        }
        //on document ready update rule operators
        var table_length = $('table.csd-rules-table.widefat').length;
        csd_update_rule_operator(table_length);

        //Cliparts add image
        $(document).on("click", ".csd-add-cliparts", function (e) {
            e.preventDefault();
            var selector = $(this).attr('data-selector');
            var trigger = $(this);
            var uploader = wp.media({
                title: 'Please set the picture',
                button: {
                    text: "Set Image"
                },
                multiple: true
            })
                    .on('select', function () {
                        var selection = uploader.state().get('selection');
                        selection.map(
                                function (attachment) {
                                    attachment = attachment.toJSON();
                                    var code = "<input type='hidden' value='" + attachment.id + "' name='selected-cliparts[]'>";
                                    code = code + "<span class='csd-clipart-holder'><img src='" + attachment.url + "'>";
                                    code = code + "<label>Price: <input type='text' value='0' name='csd-cliparts-prices[]'></label>";
                                    code = code + "<a href='#' class='button csd-remove-clipart' data-id='" + attachment.id + "'>Remove</a></span>";
                                    $("#cliparts-container").prepend(code);
                                }
                        );
                    })
                    .open();
        });

        $(document).on("click", ".csd-remove-clipart", function (e) {
            e.preventDefault();
            var id = $(this).data("id");
            $('#cliparts-form > input[value="' + id + '"]').remove();
            $(this).parent().remove();
        });

        /*
         * 
         * auto load font data
         */
        $(document).on('change', '#font', function () {
            var name = $('#font  option:selected').text();
            var url = $('#font   option:selected').val();
            $('.font_auto_name').val(name);
            $('.font_auto_url').val(url);

        });
        /*
         * end ------------------------------------------------------------------------
         */

        /*
         * font type
         */
        $('#csd_fonts_selector, #csd_cliparts_selector').select2({
            tags: true,
            width: 500
        });
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * 
         * Newsletter
         */
        $(document).on("click", "#csd-dismiss", function () {
            $.post(
                    csd_ajax_url,
                    {
                        action: "csd_hide_notice",
                    },
                    function (data) {
                        if (data === "ok") {
                            $('#csd-subscription-notice').hide();
                        }
                    })
                    .fail(function (xhr, status, error) {
                        alert(error);
                    });

        });

        $(document).on("click", "#csd-subscribe", function () {
            $("#csd-subscribe-loader").show();
            $("#csd-subscribe").attr("disabled", true);
            $("#csd-subscribe").addClass('disabled');
            if (!$('#o_user_email').val()) {
                alert('No email found. Please add an email address to subscribe.');
                $("#csd-subscribe-loader").hide();
                $("#csd-subscribe").attr("disabled", false);
                $("#csd-subscribe").removeClass('disabled');
            } else {
                var email = $('#o_user_email').val();
                var csd_subscription_nonce = $('#csd_subscription_nonce').val();
                $.post(
                        csd_ajax_object.csd_ajax_url,
                        {
                            action: "csd_subscribe",
                            email: email,
                            csd_subscription_nonce: csd_subscription_nonce
                        },
                        function (data) {
                            if (data === "true") {
                                $("#csd-subscribe-loader").hide();
                                $('#csd-subscription-notice').hide();
                                $('#csd-subscription-success-notice').show();
                            } else {
                                $("#csd-subscribe-loader").hide();
                                $("#csd-subscribe").attr("disabled", false);
                                $("#csd-subscribe").removeClass('disabled');
                                alert(data);
                            }
                        })
                        .fail(function (xhr, status, error) {
                            $("#csd-subscribe-loader").hide();
                            $("#csd-subscribe").attr("disabled", false);
                            $("#csd-subscribe").removeClass('disabled');
                            alert(error);
                        });
            }

        });
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * add font file
         */

        $(document).on("click", ".o-add-font-file", function (e) {
            e.preventDefault();
            var uploader = wp.media({
                title: 'Please set the font',
                button: {
                    text: "Select font(s)"
                },
                multiple: false
            })
                    .on('select', function () {
                        var selection = uploader.state().get('selection');
                        selection.map(
                                function (attachment) {
                                    attachment = attachment.toJSON();
                                    var new_rule_index = $(".font_style_table tbody tr").length;
                                    var font_tpl = $("#csd-font-tpl").val();
                                    var tpl = font_tpl.replace(/{index}/g, new_rule_index);
                                    $('.font_style_table tbody').prepend(tpl);
                                    $('#file_data_' + new_rule_index).find("input[type=hidden]").val(attachment.id);
                                    $('#file_data_' + new_rule_index).parent().find(".media-name").html(attachment.filename);
                                }
                        );
                    })
                    .open();
        });
        /*
         * end ------------------------------------------------------------------------
         */

        /*
         * Remove font
         */
        $(document).on("click", ".o-remove-font-file", function (e) {
            e.preventDefault();
            $(this).parent().find("input[type=hidden]").val("");
            $(this).parent().parent().find(".media-name").html("");
            $(this).parent().parent().remove();
        });
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * canvas background color
         */
        $(document).on("change", ".csd-bg-type", function (e)
        {
            get_bg_fields_based_on_type();

        });

        if ($('.csd-bg-type').length > 0) {
            setTimeout(
                    function () {
                        get_bg_fields_based_on_type();
                    }, 1000);
        }

        function get_bg_fields_based_on_type()
        {
            $("[class*='show-if-canvas-']").hide();
            var selected_value = $('.csd-bg-type input:checked').val();
            if (selected_value === "colors")
            {
                $('.show-if-canvas-colors').show();
            } else if (selected_value === "colorpicker")
            {
                $('.show-if-canvas-colorpicker').show();
            } else {
                $('.show-if-canvas-colors').hide();
                $('.show-if-canvas-colorpicker').hide();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */

        /*
         *Clipart
         */

        $(document).on("change", ".csd-cliparts-group", function () {
            csd_get_cliparts_field_based_on_type();
        });

        if ($('.csd-cliparts-group').length) {
            csd_get_cliparts_field_based_on_type();
        }

        function csd_get_cliparts_field_based_on_type()
        {
            $("select[name='csd-metas[global-cliparts][selected-cliparts][]']").parent().parent().hide();
            var selected_value = $('.csd-cliparts-group input:checked').val();

            if (selected_value.indexOf("no") >= 0)
            {
                $("select[name='csd-metas[global-cliparts][selected-cliparts][]']").parent().parent().show();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * text shadow color
         */
        $(document).on("change", ".csd-shadow-type", function (e)
        {
            get_shadow_fields_based_on_type();

        });

        if ($('.csd-shadow-type').length > 0) {
            setTimeout(
                    function () {
                        get_shadow_fields_based_on_type();
                    }, 1000);
        }

        function get_shadow_fields_based_on_type()
        {
            $("[class*='show-if-shadow-']").hide();
            var selected_value = $('.csd-shadow-type input:checked').val();
            if (selected_value === "colors")
            {
                $('.show-if-shadow-colors').show();
            } else if (selected_value === "colorpicker")
            {
                $('.show-if-shadow-colorpicker').show();
            } else {
                $('.show-if-shadow-colors').hide();
                $('.show-if-shadow-colorpicker').hide();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */

        /*
         * show / hide shadow fields
         */
        $(document).on("change", ".csd-enable-shadow", function (e)
        {
            get_shadow_fields_based_on_selection();

        });

        if ($('.csd-enable-shadow').length > 0) {
            setTimeout(
                    function () {
                        get_shadow_fields_based_on_selection();
                    }, 1000);
        }

        function get_shadow_fields_based_on_selection()
        {
            $('.csd-shadow-field').hide();
            var selected_value = $('.csd-enable-shadow input:checked').val();
            if (selected_value === "yes")
            {
                $('.csd-shadow-field').show();
                get_shadow_fields_based_on_type();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * text outline color
         */
        $(document).on("change", ".csd-outline-type", function (e)
        {
            get_outline_fields_based_on_type();

        });

        if ($('.csd-outline-type').length > 0) {
            setTimeout(
                    function () {
                        get_outline_fields_based_on_type();
                    }, 1000);
        }

        function get_outline_fields_based_on_type()
        {
            $("[class*='show-if-outline-']").hide();
            var selected_value = $('.csd-outline-type input:checked').val();
            if (selected_value === "colors")
            {
                $('.show-if-outline-colors').show();
            } else if (selected_value === "colorpicker")
            {
                $('.show-if-outline-colorpicker').show();
            } else {
                $('.show-if-outline-colors').hide();
                $('.show-if-outline-colorpicker').hide();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */

        /*
         * show / hide outline fields
         */
        $(document).on("change", ".csd-enable-outline", function (e)
        {
            get_outline_fields_based_on_selection();

        });

        if ($('.csd-enable-outline').length > 0) {
            setTimeout(
                    function () {
                        get_outline_fields_based_on_selection();
                    }, 1000);
        }

        function get_outline_fields_based_on_selection()
        {
            $('.csd-outline-field').hide();
            var selected_value = $('.csd-enable-outline input:checked').val();
            if (selected_value === "yes")
            {
                $('.csd-outline-field').show();
                get_outline_fields_based_on_type();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */

        /*
         * show / hide radius fields
         */
        $(document).on("change", ".csd-enable-radius", function (e)
        {
            get_radius_fields_based_on_selection();

        });

        if ($('.csd-enable-radius').length > 0) {
            setTimeout(
                    function () {
                        get_radius_fields_based_on_selection();
                    }, 1000);
        }

        function get_radius_fields_based_on_selection()
        {
            $('.csd-radius-field').hide();
            var selected_value = $('.csd-enable-radius input:checked').val();
            if (selected_value === "yes")
            {
                $('.csd-radius-field').show();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * show / hide spacing fields
         */
        $(document).on("change", ".csd-enable-spacing", function (e)
        {
            get_spacing_fields_based_on_selection();

        });

        if ($('.csd-enable-spacing').length > 0) {
            setTimeout(
                    function () {
                        get_spacing_fields_based_on_selection();
                    }, 1000);
        }

        function get_spacing_fields_based_on_selection()
        {
            $('.csd-spacing-field').hide();
            var selected_value = $('.csd-enable-spacing input:checked').val();
            if (selected_value === "yes")
            {
                $('.csd-spacing-field').show();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * text color type
         */
        $(document).on("change", ".csd-text-color-type", function (e)
        {
            get_text_colors_fields_based_on_type();

        });

        if ($('.csd-text-color-type').length > 0) {
            setTimeout(
                    function () {
                        get_text_colors_fields_based_on_type();
                    }, 1000);
        }

        function get_text_colors_fields_based_on_type()
        {
            $("[class*='show-if-text-']").hide();
            var selected_value = $('.csd-text-color-type input:checked').val();
            if (selected_value === "colors")
            {
                $('.show-if-text-colors').show();
            } else {
                $('.show-if-text-colorpicker').show();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */

        /*
         * dimensions type
         */
        $(document).on("change", ".csd-dimensions-type", function (e)
        {
            get_dimensions_fields_based_on_type();

        });

        if ($('.csd-dimensions-type').length > 0) {
            setTimeout(
                    function () {
                        get_dimensions_fields_based_on_type();
                    }, 1000);
        }

        function get_dimensions_fields_based_on_type()
        {
            $("[class*='show-if-dimensions-']").hide();
            var selected_value = $('.csd-dimensions-type input:checked').val();
            if (selected_value === "font-size")
            {
                $('.show-if-dimensions-font').show();
            } else {
                $('.show-if-dimensions-canvas').show();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */



        /*
         * Rules
         */
        $(document).on("click", ".csd-add-rule", function (e)
        {
            var new_rule_index = $(".csd-rules-table tr").length;
            var group_index = $(this).data("group");
            var raw_tpl = $("#csd-rule-tpl").val();
            var tpl1 = raw_tpl.replace(/{rule-group}/g, group_index);
            var tpl2 = tpl1.replace(/{rule-index}/g, new_rule_index);
            $(this).parents(".csd-rules-table").find("tbody").append(tpl2);
            $(this).parents(".csd-rules-table").find(".a_price").attr("rowspan", new_rule_index + 1);
            //update rule operators
            var table_length = $('table.csd-rules-table.widefat').length;
            csd_update_rule_operator('', group_index, new_rule_index);
        });

        $(document).on("click", ".csd-add-group", function (e)
        {
            var new_rule_index = 0;
            var group_index = $(".csd-rules-table").length;
            var raw_tpl = $("#csd-first-rule-tpl").val();
            var tpl1 = raw_tpl.replace(/{rule-group}/g, group_index);
            var tpl2 = tpl1.replace(/{rule-index}/g, new_rule_index);
            var html = '<table class="csd-rules-table widefat"><tbody>' + tpl2 + '</tbody></table>';
            $(".csd-rules-table-container").append(html);
            //update rule operators
            var table_length = $('table.csd-rules-table.widefat').length;
            csd_update_rule_operator('', group_index, new_rule_index);
        });

        $(document).on("click", ".csd-remove-rule", function (e)
        {
            var nb_rules = $(".csd-rules-table tr").length;
            $(this).parents(".csd-rules-table").find(".a_price").attr("rowspan", nb_rules - 1);
            $(this).parents("tr").remove();

        });
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * output format ------------------------------------------------------------------------
         */
        function get_output_fields_based_on_format()
        {
            $("[class*='show-if-']").hide();
            var selected_value = $('.config-output-format input:checked').val();
//            console.log(selected_value);
            if (selected_value.indexOf("pdf") >= 0)
            {
                $('.show-if-pdf').show();
                $('.hide-if-pdf').hide();
            } else
            {
                $('.show-if-pdf').hide();
                $('.hide-if-pdf').show();
            }

            if (selected_value.indexOf("jpg") >= 0)
                $('.show-if-jpg').show();
            else
                $('.show-if-jpg').hide();

            //Zip output
            $(".show-if-zip").hide();
            var zip = $('.zip-output input:checked').val();
            if (zip == 'yes')
                $('.show-if-zip').show();
            else
                $('.show-if-zip').hide();
        }


        $(document).on("change", ".config-output-format input, .zip-output input", function (e)
        {
            get_output_fields_based_on_format();

        });

        if ($('.config-output-format').length) {
            get_output_fields_based_on_format();
        }
        /*
         * end ------------------------------------------------------------------------
         */



        /*
         * font type
         */
        $('#csd_fonts_selector').select2({
            tags: true,
            width: 500
          });
        
        $("ul.select2-selection__rendered").sortable({
            containment: 'parent'
        });
        
        $('#csd_fonts_selector').on('select2:select', function(e) {
            console.log('change');
            var element = $(this).find('[value="' + e.params.data.id + '"]');
            $(this).append(element);
            $(this).trigger('change');
          });

        $(document).on("change", ".csd-fonts-type", function (e)
        {
            get_fonts_field_based_on_type();

        });

        if ($('.csd-fonts-type').length) {
            get_fonts_field_based_on_type();
        }

        function get_fonts_field_based_on_type()
        {
            $("[class*='show-if-fonts-global-']").hide();
            var selected_value = $('.csd-fonts-type input:checked').val();

            if (selected_value.indexOf("no") >= 0)
            {
                $('.show-if-fonts-global-no').show();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * load colorpicker ------------------------------------------------------------------------
         */
        $(document).on("click", ".o-color-btn", function () {
            console.log("clicked");
            load_color_picker();
        });

        function load_color_picker() {
            $('.o-color').each(function (index, element)
            {
                var e = $(this);
                var initial_color = e.val();
                e.css("border-left", "35px solid " + initial_color);
                $(this).parent().find('.o-color-btn').ColorPicker({
                    color: initial_color,
                    onShow: function (colpkr) {
                        $(colpkr).fadeIn(500);
                        return false;
                    },
                    onChange: function (hsb, hex, rgb) {
                        e.css("border-left", "35px solid #" + hex);
                        e.val("#" + hex);
                        e.trigger("input");
                    }
                });
            });
        }
        /*
         * end ------------------------------------------------------------------------
         */

        /**
         * Redirection on the new ticket page once the user clicks on Request a feature on the menu
         */
        $(document).on("click", function (event) {
            var text = $(event.target).text();
            if ("Request a feature" === text) {
                event.preventDefault();
                window.open('https://orionorigin.freshdesk.com/support/tickets/new');
            }

        });

        /**
         * Show the modal box once the user clicks on the view design button
         */


        $(".csd-view-design").click(function (e) {
            var modal_id = $(this).attr('data-target');
            $(modal_id + '.csd-modal').omodal("show");
        });


        //Activate license.
        $("#csd-activate").on("click", function () {
            var code = 0;
            request_registration(code);
        });

        function request_registration(code) {
            $("#csd-spinner").css('display', 'inline-block');
            $.post(
                    csd_ajax_object.csd_ajax_url,
                    {
                        action: "csd_activate_license",
                        code: code
                    },
                    function (data) {
                        $("#csd-spinner").css('display', 'none');
                        switch (data) {
                            case "license_key_used_on_different_site":
                                if (confirm("This license key has been used for another website. Do you want to use it anyway? (this will deactivate the previous website activated)")) {
                                    var code = 1;
                                    request_registration(code);
                                } else {
                                    $('#csd-license-message').html("<p>Operation cancelled.</p>");
                                }
                                break;
                            case "200":
                                alert("Activation succeded! Your product is now activated");
                                document.location.reload(true);
                                break;
                            default:
                                alert(data);
                                $('#csd-license-message').html("<p>" + data + "</p>");
                                break;
                        }
                    })
                    .fail(function (xhr, status, error) {
                        $("#csd-spinner").css({display: "none"});
                        $('#csd-license-message').html("<p>Activation failed due to a network error. Please, retry later. </p>");
                        alert("Activation failed due to a network error. Please, retry later.");
                    });
        }

        function convert_to_px(dimensions, unit){
            var dimensions = dimensions;
            var unit = unit;
            if (typeof unit != 'undefined' && typeof dimensions != 'undefined'){
                switch ( unit ) {
                    case 'Cm':
                        dimensions = dimensions * 120;
                        break;
                    case 'Inch':
                        dimensions = dimensions * 300 ;
                        break;
                    case 'Feet':
                        dimensions = dimensions * 3600 ;
                        break;
                    case 'Px':
                        dimensions = dimensions;
                    default:
                        break;

                }
                return parseFloat(dimensions).toFixed(2);
            }  
        }

        /**
         * Controle dimension of canvas
         */

        $(".canvas_dimensions, #default_unit").bind("change", function(){
            var canvas_w = $("#canvas_w").val();
            var canvas_h = $("#canvas_h").val();
            var unit = $("#default_unit").val();

            canvas_w = convert_to_px(canvas_w, unit);
            canvas_h = convert_to_px(canvas_h, unit);

            if(canvas_w > 15000 || canvas_h > 15000){
                if(unit == "Inch"){
                    alert('The size of the canvas should not exceed 50in X 50in');
                    $('#canvas_w').val(50);
                    $('#canvas_h').val(50);   
                }
                if(unit == "Cm"){
                    alert('The size of the canvas should not exceed 125cm X 125cm');
                    $('#canvas_w').val(125);
                    $('#canvas_h').val(125); 
                }
                if(unit == "Feet"){
                   alert('The size of the canvas should not exceed 4.16ft X 4.16ft');
                    $('#canvas_w').val(4);
                    $('#canvas_h').val(4);  
                }
                if(unit == "Px"){
                   alert('The size of the canvas should not exceed 15000px X 15000px');
                    $('#canvas_w').val(15000);
                    $('#canvas_h').val(15000);  
                }
            }
        });

    });

})(jQuery);
