<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of class-csd-editor
 *
 * @author HL
 */
class CSD_Editor {

    public $item_id;
    public $root_item_id;
    public $csd_product;

    public function __construct($item_id) {
        if ($item_id) {
            $this->item_id = $item_id;
            $this->csd_product = new CSD_Product($item_id);
            $this->root_item_id = $this->csd_product->root_product_id;
        }
    }

    public function get_editor() {
        global $csd_settings;
        ob_start();
        $product = wc_get_product($this->item_id);
        // var_dump($product);
        if (!$product) {
            esc_attr_e('Error: Invalid product: ', 'csd');
            echo esc_attr($this->item_id);
            echo '<br>';
            esc_attr_e('1- Is your customization page defined as homepage?', 'csd');
            echo '<br>';
            esc_attr_e('2- Is your customization page defined as one of woocommerce pages?', 'csd');
            echo '<br>';
            esc_attr_e('3- Does the product you are trying to customize exists and is published in your shop?', 'csd');
            echo '<br>';
            esc_attr_e('4- Are you accessing this page from one of the product designer buttons?', 'csd') . '<br>';
            return;
        }

         if ($_SERVER['REMOTE_ADDR'] != '127.0.0.1' && $_SERVER['REMOTE_ADDR'] != '::1') {
             if (!get_option('csd-license-key')) {
                 echo '<br><h2>';
                 esc_attr_e('You have not activated your license yet. Please, activate it in order to use this plugin.', 'csd');
                 echo '</h2><br>';
                 return;
             }
         }

        $csd_metas = $this->csd_product->settings;

        csd_init_canvas_vars($csd_metas, $product, $this);
        $skin = get_proper_value($csd_metas, 'skin', 'CSD_Default_Skin');
        $editor = new $skin($this, $csd_metas);
        $raw_output = $editor->display();
        //Escaping output.
        $allowed_tags = csd_allowed_tags();
        wp_nonce_field('csd_generate_design', 'csd_generate_design_nonce');
        echo wp_kses($raw_output, $allowed_tags);
        $output = ob_get_contents();
        ob_end_clean();
        return $output;
    }

}
