(function ($) {
    "use strict";
    $(document).ready(function () {

        $(document).on('touchstart click', '#font-family-selector > div', function () {
            var vpc_get_font_selected = $(this).attr('style').replace('font-family:', '');
            $(this).parent('#font-family-selector').attr('value', vpc_get_font_selected);
            $(this).parent('#font-family-selector').trigger('change');
        });

        //        $('ul.csd-tabs li').click(function () {
        //            var csd_tab_id = $(this).attr('data-tab');
        //
        //            $('ul.csd-tabs li').removeClass('current');
        //            $('.csd-tab-content').removeClass('current');
        //
        //            $(this).addClass('current');
        //            $("#" + csd_tab_id).addClass('current');
        //        });

        $('ul.csd-tabs li').click(function () {
            var csd_tab_id = $(this).attr('data-tab');
            $(this).parents('ul.csd-tabs').find('li').removeClass('current');
            $(this).parents('.csd-tools-content').find('.csd-tab-content').removeClass('current');
            $(this).addClass('current');
            $("#" + csd_tab_id).addClass('current');
        });

        $(document).on('touchstart click', '.csd-button-bar #align_btn', function () {
            $(".csd-button-bar #csd-align-tool").toggleClass('is-open');
        });

        $(document).on('touchstart click', '.csd-button-bar #shared-btn', function () {
            $(".csd-button-bar #csd-share-tool").toggleClass('is-open');
        });

        var $first = $('li:first', 'ul#csd-parts-bar'), $last = $('li:last', 'ul#csd-parts-bar');
        $first.addClass('first');
        $last.addClass('last');
        var csd_editor = {};
        csd_editor.selected_part = -1;

        function csd_slider_nav() {
            if ($('#csd-parts-bar li.active').hasClass('first')) {
                $('.csd-part-prev').hide();
                $('.csd-part-next').show();
            } else if ($('#csd-parts-bar li.active').hasClass('last')) {
                $('.csd-part-next').hide();
                $('.csd-part-prev').show();
            } else {
                $('.csd-part-prev').show();
                $('.csd-part-next').show();
            }
        }

        csd_slider_nav();
        $(document).on('touchstart click', '#product-part-slider > span', function () {
            var $next, $selected = $(".active");
            $next = $selected.next('li').length ? $selected.next('li') : $first;
            $selected.removeClass("active");
            $next.addClass('active');
            var $this = $('#csd-parts-bar li.active');
            $this.trigger("click");
            csd_slider_nav();
        });

        $(document).on('touchstart click', '#csd-parts-bar > li', function () {
            csd_slider_nav();
        });

        function add_text_empty_msg() {
            $("#debug").html("");
            $("#debug").html("<div>" + csd.translated_strings.empty_txt_area_msg + "</div>");
        }

        function csd_hide_debug_box() {
            $('#debug-wrap').removeClass('is-open');
        }

        wp.hooks.addAction('csd.add_text_empty_msg', add_text_empty_msg);
        wp.hooks.addFilter('csd.add_not_curved_action_before', csd_hide_debug_box);
        wp.hooks.addFilter('csd.add_curved_action_before', csd_hide_debug_box);
        wp.hooks.addFilter('csd.add_text_selected', csd_recup_selected_text);

        function csd_recup_selected_text(options) {
            if (options) {
                var csd_selected_text = options.target.text;
                if (csd_selected_text) {
                    $('.csd-font-view').html(csd_selected_text);
                    $("#csd-object-width").val(csd_EDITOR.get_true_dimension(options.target.width) / csd_EDITOR.multiplier);
                    $("#csd-object-height").val(csd_EDITOR.get_true_dimension(options.target.height) / csd_EDITOR.multiplier);
                    $("#csd-font-size").val(csd_EDITOR.get_true_dimension(options.target.fontSize) / csd_EDITOR.multiplier);
                    $(".csd-object-size").attr("readonly", true);
                }
                var count = csd_get_text_nb_line(csd_selected_text, '\n') + csd_get_text_nb_line(csd_selected_text, '|n') + 1;
                if (count > 1) {
                    $('#csd-text-align-row').removeClass('csd-hide-row');
                } else {
                    $('#csd-text-align-row').addClass('csd-hide-row');
                }
                $('.csd-porto-skin .csd-tools-head').removeClass('is-active');
                $('.csd-porto-skin .csd-tools-content').removeClass('is-active');
                $('#text-panel').addClass('is-active');
                $('#text-panel').parent().find('.csd-tools-content').addClass('is-active');
                $('#text-panel').parents('.csd-editor-col').addClass('is-open');
                get_tools_content_height();
            }


            $('.csd-porto-skin .csd-tools-head').removeClass('is-active');
            $('.csd-porto-skin .csd-tools-content').removeClass('is-active');
            $('#text-panel').addClass('is-active');
            $('#text-panel').parent().find('.csd-tools-content').addClass('is-active');
            $('#text-panel').parents('.csd-editor-col').addClass('is-open');

            get_tools_content_height();
        }

        function csd_get_text_nb_line(string, substring) {
            var n = 0;
            var pos = 0;

            while (true) {
                pos = string.indexOf(substring, pos);
                if (pos !== -1) {
                    n++;
                    pos += substring.length;
                } else {
                    break;
                }
            }
            return (n);
        }

        $(document).on('click touchstart', '.csd-tools-head', function () {
            csd_EDITOR.canvas.discardActiveObject();
            $('.csd-porto-skin .csd-tools-head').removeClass('is-active');
            $('.csd-porto-skin .csd-tools-content').removeClass('is-active');
            $(this).addClass('is-active');
            $(this).parent().find('.csd-tools-content').addClass('is-active');
            $(this).parents('.csd-editor-col').addClass('is-open');
            get_tools_content_height();
        });

        $(document).on('click touchstart', '.csd-tools-close', function () {
            $(this).parents('.csd-tools-content').removeClass('is-active');
            $(this).parents('.csd-tools-wrap').find('.csd-tools-head').removeClass('is-active');
            $(this).parents('.csd-editor-col').removeClass('is-open');

        });

        function get_tools_content_height() {
            var porto_header_height = $('#header-wrap').outerHeight();
            var header_height = $('header').outerHeight();
            var wpadminbar = $('#wpadminbar').outerHeight();
            var panel_head = $('.csd-tools-content.is-active .csd-panel-head').outerHeight();
            if (wpadminbar != null && wpadminbar != 'undefined') {
                var wpadminbar2 = wpadminbar;
                wpadminbar = wpadminbar + 21;
            } else {

                wpadminbar = 0;
                var wpadminbar2 = 0;
            }
            // if (porto_header_height != null && porto_header_height != 'undefined') {
            //     porto_header_height = porto_header_height;
            // } else {
            //     porto_header_height = header_height;
            // }

            if (panel_head != null && panel_head != 'undefined') {
                panel_head = panel_head;
            } else {
                panel_head = 41;
            }


            var tools_panel = $('.csd-editor-wrap').outerHeight();
            var tools_panel_content = tools_panel - panel_head;

            var windowsize = $(window).width();
            if (windowsize >= 768) {
                $('.csd-porto-skin .csd-tab-content-wrapper > div:not(".csd-group-child-wrap"), #csd-cliparts-groups-parent-wrapper,#csd-cliparts-groups-wrapper,#tab-clipart-upload-child,#csd-team-and-number-wrapper,#csd-cart-box').css({ 'height': tools_panel_content });
                $('.csd-group-child-wrap .font-selector-container').css({ 'height': tools_panel_content - 50 });
                $('.csd-my-design-preview').css({ 'height': tools_panel_content - 100 });

            }
        }

        $(".csd-porto-skin #add-cart-content.is-open > div").mCustomScrollbar({
            axis: "y",
            theme: "minimal-dark",
            scrollInertia: 300,
            advanced: {
                autoScrollOnFocus: false,
                updateOnContentResize: true
            }
        });

        $(window).resize(function () {

            setTimeout(function () {
                $("#csd-parts-bar li:eq(" + csd_EDITOR.selected_part + ")").click();
            }, 500);
            get_tools_content_height();
        });

        $(window).load(function () {
            $('.csd-porto-skin .csd-tools-head').removeClass('is-active');
            $('.csd-porto-skin .csd-tools-content').removeClass('is-active');
            $('.csd-tools-wrap:first-child .csd-tools-head').addClass('is-active');
            $('.csd-tools-wrap:first-child .csd-tools-head').parent().find('.csd-tools-content').addClass('is-active');
            $('.csd-tools-wrap:first-child .csd-tools-head').parents('.csd-editor-col').addClass('is-open');

            get_tools_content_height();
            var windowsize = $(window).width();
            if (windowsize >= 768) {

                $('.csd-button-bar-wrap,.csd-porto-skin .csd-tab-content-wrapper > div:not(".csd-group-child-wrap"),#csd-cliparts-groups-parent-wrapper,#csd-cliparts-groups-wrapper,#tab-clipart-upload-child,#csd-cart-box,#tab-clipart-upload-child,.csd-group-child-wrap .font-selector-container,#tab-upload #acd-uploaded-img,#tab-social-facebook .img-container,#tab-social-instagram .img-container, #display_ofb').mCustomScrollbar({
                    axis: "y",
                    theme: "minimal-dark",
                    scrollInertia: 300,
                    advanced: {
                        autoScrollOnFocus: false,
                        updateOnContentResize: true
                    }
                });
            }

            $('#debug').bind('DOMNodeInserted', function (e) {
                $(this).parents('#debug-wrap').addClass('is-open');
                if ($('#debug').is(':empty')) {
                    $(this).parents('#debug-wrap').removeClass('is-open');
                } else {
                    $(this).parents('#debug-wrap').addClass('is-open');
                }
            });

            $(document).on('click touchstart', '#debug-wrap.is-open .debug-icon', function () {
                $(this).parents('#debug-wrap').removeClass('is-open');
            });

            function csd_get_greek_state() {
                if ($('#cb-greek').is(':checked')) {

                    $('.csd-greek-character-wrap').addClass('is-active');
                } else {

                    $('.csd-greek-character-wrap').removeClass('is-active');
                }
            }
            csd_get_greek_state();

            $(document).on('change', '#cb-greek', function () {
                csd_get_greek_state();
            });

            wp.hooks.addAction('csd_EDITOR.after_adding_text_on_canvas', csd_active_added_text);
            function csd_active_added_text(text, csd_canvas) {
                csd_canvas.setActiveObject(text);
                var active_w = csd_EDITOR.get_true_dimension(text.width);
                var actiive_font_size = csd_EDITOR.get_true_dimension(text.fontSize);
                actiive_font_size = actiive_font_size / csd_EDITOR.multiplier;
                var active_h = csd_EDITOR.get_true_dimension(text.height);
                $("#csd-object-width").val(active_w);
                $("#csd-object-height").val(active_h);
                $("#csd-font-size").val(actiive_font_size);
                $(".csd-canvas-size, .csd-object-size, .csd-text-size").trigger("change");
            }

            $(document).on('touchstart click', '.csd-number-input button.minus', function () {
                var recup_val = $(this).parent('.csd-number-input').find("input[type=number]").val();
                var recup_min = $(this).parent('.csd-number-input').find("input[type=number]").attr('min');
                var recup_step = $(this).parent('.csd-number-input').find("input[type=number]").attr('step');
                var recup_opacity = $(this).parent('.csd-number-input').find("input[type=number]").data('opacity');
                if (recup_opacity !== true) {
                    var new_val = parseInt(recup_val) - parseInt(recup_step);
                } else {
                    var new_val = (parseFloat(recup_val) - parseFloat(recup_step)).toFixed(1);
                    var recup_min = 0.0;
                }
                if (new_val >= recup_min) {
                    if (recup_opacity === true && new_val == recup_min) {
                        var new_val = 0;
                    }
                    $(this).parent('.csd-number-input').find("input[type=number]").val(new_val);
                }
                $(this).parent('.csd-number-input').find("input[type=number]").trigger('change');
            });

            $(document).on('touchstart click', '.csd-number-input button.plus', function () {
                var recup_val = $(this).parent('.csd-number-input').find("input[type=number]").val();
                var recup_max = $(this).parent('.csd-number-input').find("input[type=number]").attr('max');
                var recup_step = $(this).parent('.csd-number-input').find("input[type=number]").attr('step');
                var recup_opacity = $(this).parent('.csd-number-input').find("input[type=number]").data('opacity');
                if (recup_opacity !== true) {
                    var new_val = parseInt(recup_val) + parseInt(recup_step);
                } else {
                    var new_val = (parseFloat(recup_val) + parseFloat(recup_step)).toFixed(1);
                    var recup_max = 1.0;
                }
                if (new_val <= recup_max) {
                    if (recup_opacity === true && new_val == recup_max) {
                        var new_val = 1;
                    }
                    $(this).parent('.csd-number-input').find("input[type=number]").val(new_val);
                }
                $(this).parent('.csd-number-input').find('input[type=number]').trigger('change');
            });

            $(document).on('touchstart click', '.csd-font-group-wrap .csd-font-group', function () {
                $(this).parents('.csd-tab-content-wrapper').find('.csd-group-child-wrap').addClass('is-open');
            });

            $(document).on('touchstart click', '#tab-saved-design .csd_order_item', function () {
                $(this).parents('.csd-tab-content-wrapper').find('.csd-group-child-wrap').addClass('is-open');
            });

            $(document).on('touchstart click', '.csd-cliparts-groups-parent > li,#csd-search-cliparts-group-parent-results > li', function () {
                var group_parent_id = $(this).data("group-parent-id");
                var group_parent_name = $(this).html();
                $('#csd-clipart-group-parent-selected').html(group_parent_name);
                $(this).parents('.csd-tools-content').find('.csd-group-parent-child-wrap').addClass('is-open');

            });

            $(document).on('touchstart click', '.csd-child-wrap-close', function () {
                $(this).parents('.csd-group-child-wrap').removeClass('is-open');
            });

            $(document).on('touchstart click', '.csd-parent-wrap-close', function () {
                $(this).parents('.csd-group-parent-child-wrap').removeClass('is-open');
            });

            $(document).on('touchstart click', '.csd-clipart-edit-close', function () {
                $(this).parents('#csd-cliparts-filters-wrap').removeClass('is-open');
            });

            $(document).on('touchstart click', '.csd-upload-edit-close', function () {
                $(this).parents('#csd-uploads-filters-wrap').removeClass('is-open');
            });

            wp.hooks.addAction('csd_EDITOR.object_deselected', csd_object_deselected);
            function csd_object_deselected(options, image_type) {
                var csd_object_type = options.target.type;


                $('#csd-text-align-row').addClass('csd-hide-row');
                $('#copy_paste_btn,#align_btn,#delete_btn,#clear_all_btn').addClass('csd_btn_hidden');
                $('.csd-button-bar #csd-align-tool').removeClass("is-open");
                $('.csd-object-size').prop('disabled', true);
                // $('.csd-text-size').prop('disabled',true);

                if (csd_object_type == "text" || (csd_object_type == "group") && options.target.get("originalText")) {
                    $('.csd-font-view').html('Hello');
                    $('#csd-add-text').text('Add');
                }

                if (csd_object_type == "path-group" || csd_object_type == "image") {
                    $('#csd-filters-tools-wrap').removeClass('is-active');
                }
                if (image_type === "cliparts-panel") {
                    $('#csd-cliparts-filters-wrap').removeClass('is-open');
                } else if (image_type === "uploads-panel") {
                    $('#csd-uploads-filters-wrap').removeClass('is-open');
                }
            }

            wp.hooks.addAction('csd_EDITOR.image_selected', csd_open_clipart_editor);
            function csd_open_clipart_editor(option, image_type) {
                $('#csd-filters-tools-wrap').addClass('is-active');
                $('#csd-uploads-filters-wrap').addClass('is-open');
                $(".csd-object-size").removeAttr("readonly");
                var active_w = option.width;
                var active_h = option.height;
                $("#csd-object-width").val(csd_EDITOR.get_true_dimension(active_w * option.scaleX) / csd_EDITOR.multiplier);
                $("#csd-object-height").val(csd_EDITOR.get_true_dimension(active_h * option.scaleY /  csd_EDITOR.multiplier));
            }

            wp.hooks.addAction('csd_EDITOR.object_selected', csd_any_object_selected);
            function csd_any_object_selected(options) {
                var csd_object_type = options.target.type;
                $(".csd-button-bar > .csd_btn_hidden").removeClass('csd_btn_hidden');
                if (csd_object_type == "text" || (csd_object_type == "group") && options.target.get("originalText")) {
                    // $('.csd-text-size').prop('disabled',false);
                    $('.csd-object-size').prop('disabled', true);
                    $('#csd-add-text').text('Edit');
                } else {
                    $('.csd-object-size').prop('disabled', false);
                    // $('.csd-text-size').prop('disabled',true);
                }

            }

            $('#cb-add-name').change(function () {
                csd_get_team_name_tools();

            });

            $('#cb-add-number').change(function () {
                csd_get_team_number_tools();

            });

            //csd_get_team_name_tools();
            //csd_get_team_number_tools();

            $(document).on('touchstart click', '#csd-add-team-info,.csd-greek-character-wrap > div,.csd-facebook.acd-social-login,.csd-instagram.acd-social-login', function () {
                alert("Not yet implemented");
                return false;
            });

            // Add manage team row
            $('.csd-add-team-row').click(function () {
                var lastRepeatingGroup = $('.csd-team-row').last();
                lastRepeatingGroup.clone().insertAfter(lastRepeatingGroup);
                return false;
            });

            // Delete manage team row
            $('.csd-remove-team-row').click(function () {
                $(this).parents('.csd-team-row').remove();
                return false;
            });

            $(document).on('touchstart click', '.csd-custom-select-cover', function () {

                var UnitList = $(this).parents('.csd-custom-select-wrap').find('.csd-custom-select-content');
                $('.csd-custom-select-wrap .csd-custom-select-content').addClass('hidden');
                if (UnitList.hasClass('hidden')) {
                    UnitList.removeClass('hidden');
                } else {

                    UnitList.addClass('hidden');

                }

            });


            $(document).mouseup(function (e) {
                var container = $('.csd-custom-select-cover');
                var UnitList = $('.csd-custom-select-content');
                // if the target of the click isn't the container nor a descendant of the container
                if (!container.is(e.target) && container.has(e.target).length === 0) {
                    UnitList.addClass('hidden');
                }
            });
            $('.csd-custom-select-wrap ul li').on('click', function () {
                var UnitList = $(this).parents('.csd-custom-select-wrap').find('.csd-custom-select-content');
                $(this).parents('.csd-custom-select-wrap').find('.csd-custom-select').attr("value", $(this).text());
                UnitList.addClass('hidden');
            });

            $('.csd-option-ratio-object, .csd-option-ratio-canvas').on('touchstart click', function () {
                if ($(this).hasClass('active')) {
                    $(this).removeClass('active');
                } else {
                    $(this).addClass('active');
                }
            });

            // $(".csd-color-spectrum").spectrum({
            //     flat: true,
            //     showAlpha: false,
            //     allowAlpha: true,
            //     showPalette: false,
            //     showButtons: false,
            //     clickoutFiresChange: true,
            //     preferredFormat: "hex",
            //     move: function (color) {
            //         $(this).parents(".csd-tool-row").find(".csd-color-value").val(color);
            //     }
            // });
            //Change ColorPicker value according to text user entered in field
            // $(document).on('change', '.csd-color-value', function () {
            //     $(this).parents(".csd-tool-row").find(".csd-color-spectrum").spectrum("set", $(this).val());
            // });

            //no background-color for Layout 
            // $(document).on('change', 'label.csd-bg-or-not input[type="checkbox"]', function () {
            //     var fieldColorValue = $(this).parents(".csd-tool-row").find(".csd-color-value");
            //     if ($(this).is(":checked"))
            //         fieldColorValue.val('').prop('disabled', true);
            //     else
            //         fieldColorValue.prop('disabled', false);
            // });



        });

    });

})(jQuery);