var csd_EDITOR = (function ($, csd_editor) {
    $(document).ready(function () {
        //Lazy load
        function init_lazy_loader(container)
        {
            $("img.o-lazy").lazyload({
                placeholder: csd.lazy_placeholder,
                container: $(container),
                skip_invisible: true
            });
        }

        init_lazy_loader("#csd-cliparts-wrapper");

        $(document).on("click", ".csd-cliparts-groups>li,#csd-search-cliparts-group-results > li", function (e) {
            show_all_cliparts();
            var group_id = $(this).data("groupid");
            var group_name = $(this).html();
            $(".csd-cliparts-container").hide();
            $(".csd-cliparts-groups>li").removeClass("selected");
            $(this).addClass("selected");
            $(".csd-cliparts-container[data-groupid=" + group_id + "]").show();
            setTimeout(function () {
                $(".csd-cliparts-container[data-groupid=" + group_id + "]").trigger("scroll");
            }, 500);
            $('#csd-clipart-group-selected').html(group_name);
            $('#cliparts-panel-content-child').addClass('is-open');

        });

        $(".csd-cliparts-container").bind('scrollstop', function (e) {
            $(".csd-cliparts-container:visible").trigger("scroll");
        });

        $(document).on("click", "#csd-cliparts-opener", function (e) {
            $(".csd-cliparts-groups>li").first().click();
        });

        //setup before functions
        var typingTimer;                //timer identifier
        var doneTypingInterval = 1000;  //time in ms, 5 second for example
        var $input = $('#csd-cliparts-search');
        var $input_group_parent = $('#csd-cliparts-group-parent-search');
        var $input_group = $('#csd-cliparts-group-search');

        //on keyup, start the countdown
        $input.on('keyup', function () {
            clearTimeout(typingTimer);
            typingTimer = setTimeout(doneTyping, doneTypingInterval);
        });

        //clipart_parent_group
        $input_group_parent.on('keyup', function () {
            clearTimeout(typingTimer);
            typingTimer = setTimeout(doneTyping_group_parent, doneTypingInterval);
        });
        //clipart_group
        $input_group.on('keyup', function () {
            clearTimeout(typingTimer);
            typingTimer = setTimeout(doneTyping_group, doneTypingInterval);
        });

        //on keydown, clear the countdown 
        $input.on('keydown', function () {
            clearTimeout(typingTimer);
        });

        //clipart_parent_group
        $input_group_parent.on('keydown', function () {
            clearTimeout(typingTimer);
        });
        //clipart_group
        $input_group.on('keydown', function () {
            clearTimeout(typingTimer);
        });

        //user is "finished typing," do something
        function doneTyping() {
            $("#csd-search-cliparts-results").html("");
            var preview_list = $('#csd-all-cliparts').html();
            var searched_value = $input.val().toLowerCase();
            if (searched_value.length > 0) {
                var recup_gp = $('.csd-cliparts-groups-parent li').filter(function () {
                    return $(this).attr('data-group-parent-name').toLowerCase().indexOf(searched_value) > -1;
                });
                var recup_g = $('.csd-cliparts-groups li').filter(function () {
                    return $(this).attr('data-group-name').toLowerCase().indexOf(searched_value) > -1;
                });
                var results = [];
                results.push(recup_gp);
                results.push(recup_g);
                if (results.length) {
                    var get_result_list = {};
                    var result = [];
                    $.each(results[0], function (index, value) {
                        get_result_list = value;
                        get_id = $(this).attr('data-group-parent-id');
                        result.push(get_id);
                    });
                    $.each(results[1], function (index, value) {
                        get_result_list = value;
                        get_id = $(this).attr('data-groupid');
                        result.push(get_id);
                    });

                    var unique = result.filter(function (get_id, i, a) {
                        return i == result.indexOf(get_id);
                    });
                    if (unique.length) {
                        var recup = $('#csd-all-cliparts .csd-cliparts-container').filter(function () {
                            return $.inArray($(this).attr('data-groupid'), unique);
                        });
                        if (recup.length) {
                            var get_result_clone = recup.clone();
                            $("#csd-search-cliparts-results").html(get_result_clone);
                        }
                    } else {
                        $("#csd-search-cliparts-results").html(csd.translated_strings.cliparts_search_no_result);
                    }

                } else {
                    $("#csd-search-cliparts-results").html(csd.translated_strings.cliparts_search_no_result);
                }
                show_cliparts_search_results();
            } else {
                $("#csd-all-cliparts").show();
                $("#csd-search-cliparts-results").hide();
            }

        }

        //clipart_parent_group
        function doneTyping_group_parent() {
            $("#csd-search-cliparts-group-parent-results").html("");
            var preview_list = $('.csd-cliparts-groups-parent').html();
            var searched_value = $input_group_parent.val().toLowerCase();
            if (searched_value.length > 0) {
                var recup_gp = $('.csd-cliparts-groups-parent li').filter(function () {
                    return $(this).attr('data-group-parent-name').toLowerCase().indexOf(searched_value) > -1;
                });
                var recup_g = $('.csd-cliparts-groups li').filter(function () {
                    return $(this).attr('data-group-name').toLowerCase().indexOf(searched_value) > -1;
                });
                var results = [];
                results.push(recup_gp);
                results.push(recup_g);
                if (results.length) {
                    var get_result_list = {};
                    var result = [];
                    $.each(results[0], function (index, value) {
                        get_result_list = value;
                        get_id = $(this).attr('data-group-parent-id');
                        result.push(get_id);
                    });
                    $.each(results[1], function (index, value) {
                        get_result_list = value;
                        get_id = $(this).attr('data-groupid');
                        result.push(get_id);
                    });

                    var unique = result.filter(function (get_id, i, a) {
                        return i == result.indexOf(get_id);
                    });
                    if (unique.length) {
                        var recup = $('#csd-all-cliparts .csd-cliparts-container').filter(function () {
                            return $.inArray($(this).attr('data-groupid'), unique);
                        });
                        if (recup.length) {
                            var get_result_clone = recup.clone();
                            $("#csd-search-cliparts-group-parent-results").html(get_result_clone);
                        }
                    } else {
                        $("#csd-search-cliparts-group-parent-results").html(csd.translated_strings.cliparts_search_no_result);
                    }

                } else {
                    $("#csd-search-cliparts-group-parent-results").html(csd.translated_strings.cliparts_search_no_result);
                }

            } else {
                $("#csd-search-cliparts-group-parent-results").html(preview_list);
            }

            show_cliparts_group_parent_search_results();
        }

        //clipart_group
        function doneTyping_group() {
            $("#csd-search-cliparts-group-results").html("");
            var preview_list = $('.csd-cliparts-groups').html();
            var searched_value = $input_group.val().toLowerCase();
            if (searched_value.length > 0) {
                var recup_gp = $('.csd-cliparts-groups-parent li').filter(function () {
                    return $(this).attr('data-group-parent-name').toLowerCase().indexOf(searched_value) > -1;
                });
                var recup_g = $('.csd-cliparts-groups li').filter(function () {
                    return $(this).attr('data-group-name').toLowerCase().indexOf(searched_value) > -1;
                });
                var results = [];
                results.push(recup_gp);
                results.push(recup_g);
                if (results.length) {
                    var get_result_list = {};
                    var result = [];
                    $.each(results[0], function (index, value) {
                        get_result_list = value;
                        get_id = $(this).attr('data-group-parent-id');
                        result.push(get_id);
                    });
                    $.each(results[1], function (index, value) {
                        get_result_list = value;
                        get_id = $(this).attr('data-groupid');
                        result.push(get_id);
                    });

                    var unique = result.filter(function (get_id, i, a) {
                        return i == result.indexOf(get_id);
                    });
                    if (unique.length) {
                        var recup = $('#csd-all-cliparts .csd-cliparts-container').filter(function () {
                            return $.inArray($(this).attr('data-groupid'), unique);
                        });
                        if (recup.length) {
                            var get_result_clone = recup.clone();
                            $("#csd-search-cliparts-group-results").html(get_result_clone);
                        }
                    } else {
                        $("#csd-search-cliparts-group-results").html(csd.translated_strings.cliparts_search_no_result);
                    }

                } else {
                    $("#csd-search-cliparts-group-results").html(csd.translated_strings.cliparts_search_no_result);
                }

            } else {
                $("#csd-search-cliparts-group-results").html(preview_list);
            }

            show_cliparts_group_search_results();
        }

        function show_cliparts_group_parent_search_results()
        {
            $(".csd-cliparts-groups-parent").hide();
            $("#csd-search-cliparts-group-parent-results").show();
            $("#csd-search-cliparts-group-parent-results .csd-cliparts-container").css('display', 'contents');
            init_lazy_loader("#csd-search-cliparts-group-parent-results");
        }

        function show_cliparts_group_search_results()
        {
            $(".csd-cliparts-groups").hide();
            $("#csd-search-cliparts-group-results").show();
            $("#csd-search-cliparts-group-results .csd-cliparts-container").css('display', 'contents');
            init_lazy_loader("#csd-search-cliparts-group-results");
        }

        function show_cliparts_search_results()
        {
            $("#csd-all-cliparts").hide();
            $("#csd-search-cliparts-results").show();
            $("#csd-search-cliparts-results .csd-cliparts-container").css('display', 'contents');
            init_lazy_loader("#csd-search-cliparts-results");
        }

        function show_all_cliparts()
        {
            $("#csd-all-cliparts").show();
            $("#csd-search-cliparts-results").hide();
        }

        //Images
        $(document).on('click', '.clipart-img img', function ()
        {
            var medium_url = $(this).attr("src");
            if (typeof medium_url == "undefined")
                medium_url = $(this).attr("data-original");
            var price = $(this).data("price");
            add_img_on_editor(medium_url, price);
            $('#csd-cliparts-modal').omodal("hide");
        });

        $(document).on("click", "#csd-add-img", function (e) {
            e.preventDefault();
            var selector = $(this).attr('data-selector');
            var trigger = $(this);
            var uploader = wp.media({
                title: 'Add image on the design area',
                button: {
                    text: "Add image"
                },
                multiple: false
            })
                    .on('select', function () {
                        var selection = uploader.state().get('selection');
                        selection.map(
                                function (attachment) {
                                    attachment = attachment.toJSON();
                                    add_img_on_editor(attachment.url);
                                }
                        )
                    })
                    .open();
        });

        $(".native-uploader #userfile").change(function () {
            var file = $(this).val().toLowerCase();
            if (file != "")
            {
                $("#userfile_upload_form").ajaxForm({
                    success: upload_image_callback
                }).submit();
            }
        });

        $('.drop a').click(function () {
            // Simulate a click on the file input button
            // to show the file browser dialog
            $(this).parent().find('input').click();
        });

        if ($('#userfile_upload_form.custom-uploader').length)
        {
            var userfile_ul = $('#userfile_upload_form.custom-uploader .acd-upload-info');
            // Initialize the jQuery File Upload plugin
            $('#userfile_upload_form.custom-uploader').fileupload({
                // This element will accept file drag/drop uploading
                dropZone: $('.drop'),
                url: csd_ajax_object.csd_ajax_url,
                // This function is called when a file is added to the queue;
                // either via the browse button, or via drag/drop:
                add: function (e, data) {
                    var tpl = $('<div class="working"><div class="acd-info"></div><div class="acd-progress-bar"><div class="acd-progress"></div></div></div>');

                    // Append the file name and file size
                    tpl.find('.acd-info').text(data.files[0].name).append('<i>' + formatFileSize(data.files[0].size) + '</i>');

                    // Add the HTML to the UL element
                    userfile_ul.html("");
                    data.context = tpl.appendTo(userfile_ul);

                    // Initialize the knob plugin
                    tpl.find('input').knob();

                    // Listen for clicks on the cancel icon
                    tpl.find('span').click(function () {

                        if (tpl.hasClass('working')) {
                            jqXHR.abort();
                        }

                        tpl.fadeOut(function () {
                            tpl.remove();
                        });

                    });

                    // Automatically upload the file once it is added to the queue
                    var jqXHR = data.submit();



                },
                progress: function (e, data) {

                    // Calculate the completion percentage of the upload
                    var progress = parseInt(data.loaded / data.total * 100, 10);

                    // Update the hidden input field and trigger a change
                    // so that the jQuery knob plugin knows to update the dial
                    data.context.find('.acd-progress').css("width", progress + "%");

                    if (progress == 100) {
                        data.context.removeClass('working');
                    }
                },
                fail: function (e, data) {
                    // Something has gone wrong!
                    data.context.addClass('error');
                },
                done: function (e, data) {
                    var name = data.files[0].name;
                    // console.log(data.result);
                    upload_image_callback(data.result, false, false, false);
                }
            });
        }

        //delete image on click on close icon
        $(document).on('touchstart click', '.csd-del-img', function () {
            var remove = $(this);
            var img_id = $(this).parent(".clipart-img-wrap").find('.clipart-img').attr("data-upload-id");
            var img_name = $(this).parent(".clipart-img-wrap").find('.clipart-img').attr("data-img-name");
            var img_url = $(this).parent(".clipart-img-wrap").find('.clipart-img').attr("data-url");

            if (undefined !== img_id && undefined !== img_name && undefined !== img_url) {
                var frm_data = new FormData();
                frm_data.append("img_id", img_id);
                frm_data.append("img_name", img_name);
                frm_data.append("img_url", img_url);
                frm_data.append("action", "csd_handle_delete_picture_upload");
                $.ajax({
                    type: 'POST',
                    url: ajax_object.ajax_url,
                    data: frm_data,
                    processData: false,
                    contentType: false
                }).done(function (data) {
                    if (is_json(data))
                    {
                        var response = JSON.parse(data);
                        if (1 === response) {
                            remove.parent(".clipart-img-wrap").remove();
                            alert("Upload delete successfuly!");
                        } else {
                            alert("Impossible de supprimer l'image");
                        }
                    }
                });
            }
        });

        // Prevent the default action when a file is dropped on the window
        $(document).on('drop dragover', function (e) {
            e.preventDefault();
        });

        $('.acd-grayscale').change(function ()
        {
            apply_filter(new fabric.Image.filters.Grayscale(), $(this).is(':checked'));

        });

        $('.acd-invert').change(function () {
            apply_filter(new fabric.Image.filters.Invert(), $(this).is(':checked'));
        });

        $('.acd-sepia').change(function () {
            apply_filter(new fabric.Image.filters.Sepia(), $(this).is(':checked'));
        });

        $('.acd-sepia2').change(function () {
            apply_filter(new fabric.Image.filters.Sepia2(), $(this).is(':checked'));
        });

        $('.acd-blur').change(function () {
            if ($(this).is(':checked'))
                $("#sharpen, #emboss").removeAttr('checked');

            apply_filter(new fabric.Image.filters.Convolute({
                matrix: [1 / 9, 1 / 9, 1 / 9,
                    1 / 9, 1 / 9, 1 / 9,
                    1 / 9, 1 / 9, 1 / 9]
            }),
                    $(this).is(':checked'));
        });

        $('.acd-sharpen').change(function () {
            if ($(this).is(':checked'))
                $("#blur, #emboss").removeAttr('checked');

            apply_filter(new fabric.Image.filters.Convolute({
                matrix: [0, -1, 0,
                    -1, 5, -1,
                    0, -1, 0]
            }),
                    $(this).is(':checked'));
        });

        $('.acd-emboss').change(function () {
            if ($(this).is(':checked'))
                $("#sharpen, #blur").removeAttr('checked');

            apply_filter(new fabric.Image.filters.Convolute({
                matrix: [1, 1, 1,
                    1, 0.7, -1,
                    -1, -1, -1]
            }), $(this).is(':checked'));
        });

        function apply_filter(filter, toApply) {

            var selected_object = csd_EDITOR.canvas.getActiveObject();

            var filter_index = jQuery.inArray(filter.type.toLowerCase(), csd_EDITOR.arr_filters);
            if ((selected_object != null) && (selected_object.type == "image"))
            {
                if (toApply)
                    selected_object.filters[filter_index] = filter;
                else
                    selected_object.filters[filter_index] = false;

                var timeStart = +new Date();

                selected_object.applyFilters();
                var timeEnd = +new Date();
                var dimString = csd_EDITOR.canvas.getActiveObject().width + ' x ' +
                  csd_EDITOR.canvas.getActiveObject().height;
                $('bench').innerHTML = dimString + 'px ' +
                  parseFloat(timeEnd-timeStart) + 'ms';
                csd_EDITOR.canvas.renderAll();
                // selected_object.applyFilters(csd_EDITOR.canvas.renderAll.bind(csd_EDITOR.canvas));
                csd_EDITOR.save_canvas();
            }

        }

        csd_editor.is_json = function (data)
        {
            if (/^[\],:{}\s]*$/.test(data.replace(/\\["\\\/bfnrtu]/g, '@').
                    replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']').
                    replace(/(?:^|:|,)(?:\s*\[)+/g, '')))
                return true;
            else
                return false;
        };

        function add_img_on_editor(url, price)
        {
            var ext = url.split('.').pop();
            if (typeof price == "undefined")
                price = 0;
            if (ext == "svg")
            {
                fabric.loadSVGFromURL(url, function (objects, options) {
                    var obj = fabric.util.groupSVGElements(objects, options);
                    optimize_img_width(obj);
                    csd_EDITOR.setCustomProperties(obj);
                    obj.set("price", price);
                    obj.set("originX", "center");
                    obj.set("originY", "center");
                    wp.hooks.doAction('csd_EDITOR.before_adding_img_on_canvas', obj);
                    if (csd_editor.box_center_x)
                    {
                        obj.center();
                        csd_editor.canvas.add(obj).calcOffset().renderAll();
                    } else
                    {
                        csd_EDITOR.canvas.add(obj);
                        obj.center();
                        csd_EDITOR.canvas.calcOffset().renderAll();
                    }
                    obj.setCoords();
                    csd_EDITOR.save_canvas();
                });
            } else
            {
                fabric.Image.fromURL(url, function (img)
                {
                    optimize_img_width(img);
                    csd_EDITOR.setCustomProperties(img);
                    img.set("price", price);
                    img.set("originX", "center");
                    img.set("originY", "center");
                    wp.hooks.doAction('csd_EDITOR.before_adding_img_on_canvas', img);
                    if (csd_EDITOR.box_center_x)
                    {
                        csd_EDITOR.canvas.add(img.set(
                                {
                                    angle: 0
                                })
                                ).renderAll();
                        img.center();
                        csd_EDITOR.canvas.calcOffset().renderAll();
                    } else
                    {
                        csd_EDITOR.canvas.add(img.set(
                                {
                                    angle: 0
                                })
                                );
                        img.center();
                        csd_EDITOR.canvas.calcOffset().renderAll();
                    }
                    wp.hooks.doAction('csd_EDITOR.after_adding_img_on_canvas', img);

                    img.setCoords();
                    csd_EDITOR.save_canvas();
                }, {crossOrigin: 'anonymous'});
            }
        }

        function optimize_img_width(obj)
        {
            // console.log(csd_EDITOR.canvas);
            var displayable_area_width = csd_EDITOR.canvas.width;
            var displayable_area_height = csd_EDITOR.canvas.height;
            if (csd.clip_w && csd.clip_h && csd.clip_w > 0 && csd.clip_h > 0 && csd.clip_type == "rect")
            {
                displayable_area_width = csd.clip_w;
                displayable_area_height = csd.clip_h;
            } else if (csd.clip_r && csd.clip_r > 0 && csd.clip_type == "arc")
            {
                displayable_area_width = csd.clip_r;
                displayable_area_height = csd.clip_r;
            }
            var dimensions = csd_EDITOR.get_img_best_fit_dimensions(obj, displayable_area_width, displayable_area_height);
            var scaleW = displayable_area_width / dimensions[0];
            var scaleH = displayable_area_height / dimensions[1];
            if (scaleW > scaleH)
                obj.scaleToWidth(dimensions[0]);
            else
                obj.scaleToHeight(dimensions[1]);
            return dimensions;
        }

        function upload_image_callback(responseText, statusText, xhr, form)
        {
            if (csd_editor.is_json(responseText))
            {
                var response = $.parseJSON(responseText);

                if (response.success)
                {
                    $("#acd-uploaded-img").find("div.mCustomScrollBox ").find("div.mCSB_container").append(response.message);
                    if (response.img_url)
                        add_img_on_editor(response.img_url, 0);
                    wp.hooks.applyFilters('csd.after_upload_image');
                } else
                    alert(response.message);
            } else
                $("#debug").html(responseText);
            $("#userfile").val("");
        }

        // Helper function that formats the file sizes
        function formatFileSize(bytes) {
            if (typeof bytes !== 'number') {
                return '';
            }

            if (bytes >= 1000000000) {
                return (bytes / 1000000000).toFixed(2) + ' GB';
            }

            if (bytes >= 1000000) {
                return (bytes / 1000000).toFixed(2) + ' MB';
            }

            return (bytes / 1000).toFixed(2) + ' KB';
        }
    });

    return csd_editor;
}(jQuery, (csd_EDITOR || {})))