var csd_EDITOR = (function ($, csd_editor) {

    $(document).on("touchstart click", "#grid-btn", function (e)
    {
        $(".upper-canvas").toggleClass("csd-canvas-grid");
    });

    $(document).on("touchstart click", "#clear_all_btn", function (e)
    {
        e.preventDefault();
        var is_confirmed = confirm(csd.translated_strings.delete_all_msg);
        if (is_confirmed)
        {
            csd_editor.canvas.clear();
            csd_editor.reload_background_overlay_if_needed(csd_editor.selected_part, csd_editor.save_canvas);
        }
    });

    $(document).on("touchstart click", "#delete_btn", function (e)
    {
        e.preventDefault();
        var selected_object = csd_editor.canvas.getActiveObject();
        var is_confirmed;
        if (selected_object != null)
        {
            if (selected_object['lockDeletion']) {
                alert(csd.translated_strings.deletion_error_msg);
            } else
            {
                is_confirmed = confirm(csd.translated_strings.delete_msg);
                if (is_confirmed)
                {
                    if (selected_object.type == "activeSelection") {
                        selected_object.forEachObject(function (a) {
                            csd_editor.canvas.remove(a);
                         });
                    }else{
                      csd_editor.canvas.remove(selected_object);                      
                    }
                    csd_editor.canvas.calcOffset();
                    csd_editor.canvas.renderAll();
                    csd_editor.save_canvas();
                }
            }
            ;
        }

    });

    $(document).on("touchstart click", "#copy_paste_btn", function (e)
    {
        e.preventDefault();
        var selected_object = csd_editor.canvas.getActiveObject();
        var selected_group;
        if (selected_object.type == "activeSelection")
            selected_group = selected_object;
        if (selected_group != null)
        {
            var new_group = new fabric.Group();
            csd_editor.canvas.discardActiveObject();
            csd_editor.canvas.renderAll();
            var objects = csd_editor.canvas.getObjects();
            $.each(objects, function (key, current_item)
            {
                if (selected_group.contains(current_item))
                {
                    cloneObject(current_item, false);
                }
            });
            csd_editor.canvas.renderAll();
            csd_editor.save_canvas();
        } else if (selected_object != null)
        {
            csd_editor.canvas.discardActiveObject();
            cloneObject(selected_object, true);
            csd_editor.save_canvas();
        }
    });

    function cloneObject(object, render_after)
    {
        var new_object = fabric.util.object.clone(object);
        new_object.set("top", new_object.top + 5);
        new_object.set("left", new_object.left + 5);
        csd_editor.setCustomProperties(new_object);
        csd_editor.canvas.add(new_object);
        if (render_after)
        {
            csd_editor.canvas.renderAll();
            csd_editor.save_canvas();
        }

    }

    $(document).on("touchstart click", "#bring_to_front_btn", function (e)
    {
        e.preventDefault();
        var selected_object = csd_editor.canvas.getActiveObject();
        var selected_group;
        if (selected_object.type == "activeSelection")
            selected_group = selected_object;
        if (typeof selected_group !== "undefined")
        {
            selected_group.forEachObject(function (a) {
                csd_editor.canvas.bringForward(a);
            });
            csd_editor.canvas.discardActiveObject();
            csd_editor.canvas.renderAll();
            csd_editor.save_canvas();

        } else if (selected_object !== null)
        {
            csd_editor.canvas.bringForward(selected_object);
            csd_editor.canvas.renderAll();
            csd_editor.save_canvas();
        }
    });

    $(document).on("touchstart click", "#send_to_back_btn", function (e)
    {
        e.preventDefault();
        var selected_object = csd_editor.canvas.getActiveObject();
        var selected_group;
        if (selected_object.type == "activeSelection")
            selected_group = selected_object;
        if (typeof selected_group !== "undefined")
        {
            csd_editor.canvas.discardActiveObject();
            selected_group.forEachObject(function (a) {
                csd_editor.canvas.sendBackwards(a);
            });
            csd_editor.canvas.renderAll();
            csd_editor.save_canvas();

        } else if (selected_object != null)
        {
            csd_editor.canvas.discardActiveObject();
            csd_editor.canvas.sendBackwards(selected_object);
            csd_editor.canvas.renderAll();
            csd_editor.save_canvas();
        }
    });

    $(document).on("touchstart click", "#flip_h_btn", function (e)
    {
        e.preventDefault();
        var selected_object = csd_editor.canvas.getActiveObject();
        var selected_group;
        if (selected_object.type == "activeSelection")
            selected_group = selected_object;
        if (typeof selected_group !== "undefined")
        {
            if (selected_group.get("flipX") == true)
                selected_group.set("flipX", false);
            else
                selected_group.set("flipX", true);
            csd_editor.canvas.renderAll();
            csd_editor.save_canvas();
        } else if (selected_object !== null)
        {
            if (selected_object.get("flipX") == true)
                selected_object.set("flipX", false);
            else
                selected_object.set("flipX", true);
            csd_editor.canvas.renderAll();
            csd_editor.save_canvas();
        }
    });

    $(document).on("touchstart click", "#flip_v_btn", function (e)
    {
        e.preventDefault();
        var selected_object = csd_editor.canvas.getActiveObject();
        var selected_group;
        if (selected_object.type == "activeSelection")
            selected_group = selected_object;
        if (typeof selected_group !== "undefined")
        {
            if (selected_group.get("flipY") == true)
                selected_group.set("flipY", false);
            else
                selected_group.set("flipY", true)
            csd_editor.canvas.renderAll();
            csd_editor.save_canvas();

        } else if (selected_object != null)
        {
            if (selected_object.get("flipY") == true)
                selected_object.set("flipY", false);
            else
                selected_object.set("flipY", true)
            csd_editor.canvas.renderAll();
            csd_editor.save_canvas();
        }

    });

    $(document).on("touchstart click", "#align_h_btn", function (e)
    {
        e.preventDefault();
        var selected_object = csd_editor.canvas.getActiveObject();
        var selected_group;
        if (selected_object.type == "activeSelection")
            selected_group = selected_object;

        if (selected_object != null)
        {
            selected_object.centerH();
            csd_editor.canvas.renderAll();
            selected_object.setCoords();
            csd_editor.save_canvas();
        } else if (selected_group != null)
        {
            selected_group.forEachObject(function (a) {
                a.centerH();
            });
            csd_editor.canvas.renderAll();
            selected_group.setCoords();
            csd_editor.save_canvas();
        }
    });

    $(document).on("touchstart click", "#align_v_btn", function (e)
    {
        e.preventDefault();
        var selected_object = csd_editor.canvas.getActiveObject();
        var selected_group;
        if (selected_object.type == "activeSelection")
            selected_group = selected_object;

        if (selected_object != null)
        {
            selected_object.centerV();
            csd_editor.canvas.renderAll();
            selected_object.setCoords();
            csd_editor.save_canvas();
        } else if (selected_group != null)
        {
            selected_group.forEachObject(function (a) {
                a.centerV();
            });
            csd_editor.canvas.renderAll();
            selected_group.setCoords();
            csd_editor.save_canvas();
        }


    });

    $(document).on("touchstart click", "#undo-btn", function (e)
    {
        e.preventDefault();
        var current_data_id = $("#csd-parts-bar > li:eq(" + csd_editor.selected_part + ")").attr("data-id");
        if (!$(this).hasClass("disabled") && csd_editor.canvasManipulationsPosition[current_data_id] > 0)
        {
            csd_editor.canvas.clear();
            csd_editor.canvasManipulationsPosition[current_data_id]--;
            csd_editor.canvas.loadFromJSON(csd_editor.serialized_parts[current_data_id][csd_editor.canvasManipulationsPosition[current_data_id]], function(){
                csd_editor.applyImageFilters();
            });
            csd_editor.refresh_undo_redo_status();
        }
    });

    $(document).on("touchstart click", "#redo-btn", function (e)
    {
        e.preventDefault();
        var current_data_id = $("#csd-parts-bar > li:eq(" + csd_editor.selected_part + ")").attr("data-id");
        var next_index = csd_editor.canvasManipulationsPosition[current_data_id] + 1;
        if (!$(this).hasClass("disabled") && typeof csd_editor.serialized_parts[current_data_id][next_index] !== "undefined")
        {
            csd_editor.canvas.clear();
            csd_editor.canvasManipulationsPosition[current_data_id] = next_index;
            csd_editor.canvas.loadFromJSON(csd_editor.serialized_parts[current_data_id][next_index], function(){
                csd_editor.applyImageFilters();
            });
            csd_editor.refresh_undo_redo_status();
        }
    });
    return csd_editor;
}(jQuery, (csd_EDITOR || {})));