<?php
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of class-vpc-default-skin
 *
 * @author HL
 */
class CSD_Default_Skin {

    public $editor;
    public $wpc_metas;

    public function __construct($editor_obj, $wpc_metas) {
        if ($editor_obj) {
            $this->editor = $editor_obj;
            $this->wpc_metas = $wpc_metas;
        }
    }

    public function content_font_family() {
        $config_metas = $this->wpc_metas;
        $use_global_fonts = get_proper_value($config_metas, 'global-fonts', 'yes');
        if ('yes' === $use_global_fonts) {
            $fonts = csd_add_ttfurl_to_font_array(get_option('csd-fonts'));
        } else {
            $selected_fonts = get_proper_value($config_metas, 'selected-fonts', 'yes');
            $fonts = csd_retrieve_fonts_data($selected_fonts);
        }
        $first_key = array_key_first($fonts);

        if(isset($fonts[$first_key]) && isset($fonts[$first_key][0]))
            $default_font = $fonts[$first_key][0];
        else $default_font = get_proper_value($config_metas, 'default-fonts');
        ?>
        <div class="csd-tab-content-wrapper">
            <div  class="csd-font-group-wrap">
                <div class="font-selector-container ">
                    <div id="font-family-selector" class="text-element-border" value = "<?php echo $default_font; ?>" style = "font-family: <?php echo $default_font; ?> ">
                        <?php
                        if (!empty($fonts)) {
                            foreach ($fonts as $font) {
                                $ttf = '';
                                if (isset($font['ttf'][0])) {
                                    $ttf = $font['ttf'][0];
                                }
                                // var_dump($ttf);
                                $bold = csd_get_font_styles($font[1], 'bold');
                                $italic = csd_get_font_styles($font[1], 'italic');
                                $both = csd_get_font_styles($font[1], 'bold-italic');
                                echo "<div style='font-family:" . $font[0] . "'>
                                    <div class='csd-font-view'>Signs Designer</div>
                                    <div class='csd-font-name'>" . __($font[0], "csd") . "</div>
                                    </div>";
                            }
                        }
                        ?>
                    </div>
                </div>

            </div>

        </div>
        <?php
    }

    public function tools_header() {
        ?>
        <div id='csd-option-top-wrap' class='csd-option-wrap'>
            <div class="csd-custom-select-wrap">
                <div class="csd-option-title"><?php _e('Units', 'csd'); ?></div>
                <div >
                    <div class="csd-custom-select-cover"></div>
                    <input type="text" name="csd-unit" value="Inch" class="csd-custom-select" id="csd-unit-select" readonly="">
                    <span class="csd-custom-select-icon icon-drop_arrow"></span>
                </div>
                <ul class="csd-custom-select-content hidden">
                    <li><?php _e('Inch', 'csd'); ?></li>
                    <li><?php _e('Cm', 'csd'); ?></li>
                    <li><?php _e('Feet', 'csd'); ?></li>
                    <li><?php _e('Px', 'csd'); ?></li>
                </ul>
            </div>
            <div>
                <div class="csd-option-title"><?php _e('Sign size', 'csd'); ?></div>
                <label><?php _e('W', 'csd'); ?></label>
                <input type='number' value='30' name='' id='csd-canvas-width' class='csd-canvas-size'>
                <label><?php _e('H', 'csd'); ?></label>
                <input type='number' value='30' name='' id='csd-canvas-height' class='csd-canvas-size'>
                <span class="csd-option-ratio-canvas icon-link active"></span>
            </div>
            <div>
                <div class="csd-option-title"><?php _e('Object size', 'csd'); ?></div>
                <label><?php _e('W', 'csd'); ?></label>
                <input type='number' name='' id='csd-object-width' class='csd-object-size' disabled="disabled">
                <label><?php _e('H', 'csd'); ?></label>
                <input type='number'  name='' id='csd-object-height' class='csd-object-size' disabled="disabled">
                <span class="csd-option-ratio-object icon-link"></span>
            </div>
            <div>
                <div class="csd-option-title"><?php _e('Text size', 'csd'); ?></div>
                <input type='number' name='' id='csd-font-size' class='csd-text-size' step = "any" min="0">
            </div>
        </div>
        <?php
    }

    public function cliparts_content() {
        ?>
        <div id="cliparts-panel-content" class="csd-tools-content">
            <div id="csd-clipart-group-container" class="csd-group-parent-child-wrap">
                <div  class="csd-panel-head">
                    <div class="csd-panel-title"><?php _e('Cliparts', 'csd'); ?></div>
                    <span id="cliparts-panel-close" class="csd-tools-close fa fa-close"></span>
                    <div class="csd-parent-wrap-close icon-557"></div>

                    <div class="csd-upload-search-wrap">
                        <span class="icon-464"></span>
                        <input type="text" id="csd-cliparts-group-search" placeholder="Search">
                    </div>
                </div>

                <div id="csd-cliparts-groups-wrapper" class="">

                    <ul class="" id="csd-search-cliparts-group-results"></ul>
                    <ul class="csd-cliparts-groups">
                        <?php
                        $args = array(
                            'numberposts' => -1,
                            'post_type' => 'csd-cliparts',
                        );
                        $cliparts_groups = get_posts($args);
                        if (isset($this->csd_metas['global-cliparts']) && 'no' === $this->csd_metas['global-cliparts']['use-global-cliparts'] && isset($this->csd_metas['global-cliparts']['selected-cliparts']) && !empty($this->csd_metas['global-cliparts']['selected-cliparts'])) {
                            $cliparts_groups_id = $this->csd_metas['global-cliparts']['selected-cliparts'];
                            $cliparts_groups = array();
                            foreach ($cliparts_groups_id as $cliparts_group_id) {
                                array_push($cliparts_groups, get_post($cliparts_group_id));
                            }
                        }

                        foreach ($cliparts_groups as $cliparts_group) {
                            $cliparts = get_post_meta($cliparts_group->ID, 'csd-cliparts-data', true);
                            if (!empty($cliparts)) {
                                ?>
                                <li data-group-name="<?= $cliparts_group->post_title; ?>" data-groupid="<?= $cliparts_group->ID; ?>"><?= $cliparts_group->post_title; ?></li>
                                <?php
                            }
                        }
                        ?>
                    </ul>

                </div>

            </div>
            <div id="cliparts-panel-content-child" class="csd-tools-content-child csd-group-child-wrap">
                <div  class="csd-panel-head">
                    <span class="csd-panel-title" id=" csd-clipart-group-selected"></span>
                    <div class="csd-child-wrap-close icon-557"></div>
                    <div class="csd-upload-search-wrap">
                        <span class="icon-464"></span>
                        <input type="text" id="csd-cliparts-search" placeholder="Search">
                    </div>
                </div>
                <div id="tab-clipart-upload-child" class="">


                    <div id="csd-cliparts-wrapper" class="">

                        <div class="" id="csd-search-cliparts-results"></div>
                        <div class="" id="csd-all-cliparts">
                            <?php
                            foreach ($cliparts_groups as $cliparts_group) {
                                $cliparts = get_post_meta($cliparts_group->ID, 'csd-cliparts-data', true);
                                if (!empty($cliparts)) {
                                    foreach ($cliparts as $clipart) {
                                        $attachment_url = o_get_proper_image_url($clipart['id']);
                                        $name = $clipart['name'];
                                        $price = $clipart['price'];
                                        if (empty($price)) {
                                            $price = 0;
                                        }
                                        ?>
                                        <div class="csd-cliparts-container" style="display: contents;" data-groupid="<?= $cliparts_group->ID; ?>" >
                                            <span class="clipart-img" data-img-name="<?= $name; ?>" data-price="<?= $price; ?>" data-original="<?= $attachment_url; ?>" data-url="<?= $attachment_url; ?>" data-src="<?= $attachment_url; ?>">
                                                <img alt="image" class="o-lazy" src="<?= $attachment_url; ?>" data-price="<?= $price; ?>" data-original="<?= $attachment_url; ?>">
                                            </span>
                                        </div>
                                        <?php
                                    }
                                }
                            }
                            ?>
                        </div>
                    </div>
                </div>       
            </div>

        </div>
        <?php
    }

    public function text_panel_content() {
        ?>
        <div class="csd-panel-head">
            <div class="csd-panel-title"><?php _e('Editing Text', 'csd'); ?></div>
            <span id="text-panel-close" class="csd-tools-close fa fa-close"></span>
            <div class="csd-text-area-wrap">
                <textarea id="new-text" placeholder="<?php echo esc_attr_e('Type something...', 'csd'); ?>" class="text-element-border text-container "></textarea>
                <button id="csd-add-text" class="csd-btn-effect"><?php _e('Add', 'csd'); ?></button>
            </div>
            <ul id="csd-text-tabs" class="csd-tabs">
                <li class="csd-tab-link current" data-tab="tab-formatting"><?php _e('Formatting', 'csd'); ?></li>
                <li class="csd-tab-link" data-tab="tab-font"><?php _e('Font Family', 'csd'); ?></li>
                <li class="csd-tab-link" data-tab="tab-text-style"><?php _e('Style', 'csd'); ?></li>
            </ul>

        </div>
        <?php
    }

    public function tab_formating() {
        ?>
        <div id="tab-formatting" class="csd-tab-content current">
            <div class="csd-tab-content-wrapper">
                <div class="">
                    <div id="csd-text-align-row" class="csd-tool-row csd-hide-row">
                        <span><?php _e('Alignment', 'csd'); ?></span>
                        <div class="csd-text-alignment">
                            <input type="radio" id="txt-align-left" name="radio" class="txt-align" value="left">
                            <label for="txt-align-left"><span class="icon-1342"></span></label>
                            <input type="radio" id="txt-align-center" name="radio" class="txt-align" value="center">
                            <label for="txt-align-center"><span class="icon-1343"></span></label>
                            <input type="radio" id="txt-align-right" name="radio" class="txt-align" value="right">
                            <label for="txt-align-right"><span class="icon-1270"></span></label>
                            <input type="radio" id="txt-align-justify" name="radio" class="txt-align" value="justify">
                            <label for="txt-align-justify"><span class="icon-1269"></span></label>
                        </div>
                    </div>
                    <div class="csd-text-curved-wrap">
                        <span class="csd-text-curved-label">
                            <span><?php _e('Curved', 'csd'); ?></span>
                            <label class="csd-switch" for="cb-curved" id="cb-curved-label">
                                <input type="checkbox" id="cb-curved" class="custom-cb checkmark"> 
                                <span class="csd-slider round"></span>
                            </label>
                        </span> 
                        <div class="csd-text-curved-content csd-tool-row">
                            <label for="radius" class="radius-label "><?php _e('Radius', 'csd'); ?></label>
                            <div>
                                <div class="csd-number-input">
                                    <button class="minus" ></button>
                                    <input name="radius" id="curved-txt-radius-slider" step="10" min="0" max="300" value="150" type="number">
                                    <button class="plus"></button>
                                </div>
                            </div>                  

                        </div>
                        <div class="csd-text-curved-content csd-tool-row">
                            <label for="spacing" class="spacing-label "><?php _e('Spacing', 'csd'); ?></label>
                            <div>
                                <div class="csd-number-input">
                                    <button class="minus" ></button>
                                    <input step="1" name="spacing" id="curved-txt-spacing-slider" min="0" max="20" value="9" type="number">
                                    <button  class="plus"></button>
                                </div>
                            </div>      

                        </div>
                    </div>
                </div>
            </div>
        </div>

        <?php
    }

    public function csd_text_style() {
        ?>
        <div class="csd-tab-content-wrapper">
            <div class="">
                <div class="csd-tool-row">
                    <!-- <span>Style</span> -->
                    <div class="csd-text-style">
                        <input type="checkbox" id="bold-cb" class="custom-cb">
                        <label  for="bold-cb" ><span class="icon-csd_icons-03"></span></label>
                        <input type="checkbox" id="italic-cb" class="custom-cb">
                        <label  for="italic-cb"><span class="icon-csd_icons-04"></span></label>
                    </div>
                </div>
                <div class="csd-tool-row no-flex">
                    <span><?php _e('Decoration', 'csd'); ?></span>
                    <div class="csd-text-decoration">
                        <input type="radio" id="underline-cb" name="txt-decoration" class="txt-decoration" value="underline">
                        <label for="underline-cb"><span class="icon-csd_icons-01"></span></label>
                        <input type="radio" id="strikethrough-cb" name="txt-decoration" class="txt-decoration" value="linethrough">
                        <label for="strikethrough-cb" ><span class="icon-csd_icons-06"></span></label>
                        <input type="radio" id="overline-cb" name="txt-decoration" class="txt-decoration" value="overline">
                        <label for="overline-cb"><span class="icon-csd_icons-05"></span></label>
                        <input type="radio" id="txt-none-cb" name="txt-decoration" class="txt-decoration" value="none">
                        <label for="txt-none-cb"><span class="icon-csd_icons-07"></span></label>
                    </div>
                </div>
                <div class="csd-tool-row no-flex">
                    <span><?php _e('Color', 'csd'); ?></span>
                    <input type="text" name="color-value" value="" id="txt-color-selector" class="csd-color-spectrum" style="background-color: #4f71b9;">
                    <input type="text" name="txt-color-value" value="" id="txt-color-selector-value" class="csd-color-value" placeholder="<?php echo esc_attr_e('Color code here', 'csd'); ?>">
                </div>
                <div class="csd-tool-row no-flex">
                    <span><?php _e('Previous color', 'csd'); ?></span>
                    <div class="csd-previous-color">
                    </div>
                </div>

                <div class="csd-tool-row">
                    <span><?php _e('Opacity', 'csd'); ?></span>
                    <div>
                        <div class="csd-number-input">
                            <button class="minus" ></button>
                            <input class="quantity" name="opacity"  id="opacity-slider" data-opacity="true" step="0.1" min="0" max="1" value="1" type="number">
                            <button  class="plus"></button>
                        </div>
                    </div>
                </div>

                <div class="csd-tool-row">
                    <span><?php _e('Background Color', 'csd'); ?></span>
                    <span id="txt-bg-color-selector-none"><?php _e('None', 'csd'); ?></span>
                    <span id="txt-bg-color-selector" class="bg-color-selector icon-1392 csd-color-icon" ><span style="background-color: transparent" class="csd-color-view"></span></span>
                </div>
                
                <!-- <div class="csd-tool-row no-flex">
                    <span><?php _e('Special characters', 'csd'); ?></span>
                    <div class="csd-text-decoration">
                        <input type="radio" id="none-sc" name="txt-special-characters" class="txt-special-characters" value="none">
                        <label for="none-sc">None</label>
                        <input type="radio" id="super-sc" name="txt-special-characters" class="txt-special-characters" value="super">
                        <label for="super-sc">Super</label>
                        <input type="radio" id="sub-sc" name="txt-special-characters" class="txt-special-characters" value="sub">
                        <label for="sub-sc" >Sub</label>
                    </div>
                </div> -->
            </div>
        </div>
        <?php
    }

    public function upload_image() {
        ?>
        <div  class="csd-panel-head">
            <div class="csd-panel-title"><?php _e('Uploads', 'csd'); ?></div>
            <span id="uploads-panel-close" class="csd-tools-close fa fa-close"></span>
            <ul id="csd-uploads-tabs" class="csd-tabs">
                <li class="csd-tab-link current" data-tab="tab-upload"><?php _e('Computer', 'csd'); ?></li>
                <li class="csd-tab-link" data-tab="tab-social-facebook"><?php _e('Facebook', 'csd'); ?></li>
                <li class="csd-tab-link" data-tab="tab-social-instagram"><?php _e('Instagram', 'csd'); ?></li>
            </ul>
        </div>
        <div id="tab-upload" class="csd-tab-content current">
            <div class="csd-tab-content-wrapper">
                <div>
                    <form id="userfile_upload_form" class="custom-uploader" method="POST" action="" enctype="multipart/form-data">
                        <input type="hidden" name="nonce" value="<?php echo wp_create_nonce('csd-picture-upload-nonce'); ?>">
                        <input type="hidden" name="action" value="csd_handle_picture_upload">
                        <div id="drop">
                            <div class="csd-uploader">
                                <?php _e('Choose a file:', 'csd'); ?>
                                <div class="csd-custom-upload-info">
                                    <?php _e('Supported format', 'csd'); ?>: PNG, JPEG (up to 10MB)<br>
                                    <?php _e('Min width', 'csd'); ?>: 1000px; <?php _e('Min height', 'csd'); ?>: 500px
                                </div>
                                <a>
                                    <?php _e('Upload a new image', 'csd'); ?>
                                    <label for="userfile"></label>
                                    <input type="file" name="userfile" id="userfile" accept="image/*">
                                </a>
                            </div>
                            <div class="acd-upload-info"></div>
                        </div>
                    </form>
                    <div class="csd-upload-search-wrap">
                        <span class="icon-464"></span>
                        <input id="csd-computer-search"  placeholder="<?php echo esc_attr_e('Search', 'csd'); ?>" type="text">
                    </div>
                    <div id="acd-uploaded-img" class="img-container">
                        <?php
                        if (!is_user_logged_in()) {
                            if (isset($_COOKIE['csd-upload']) && !empty($_COOKIE['csd-upload'])) {
                                $csd_upload_json = json_decode(base64_decode($_COOKIE['csd-upload']));
                                if (null === $csd_upload_json) {
                                    $csd_upload = array();
                                } else {
                                    $csd_upload = $csd_upload_json;
                                }
                            } else {
                                $csd_upload = array();
                            }
                            if (is_array($csd_upload) && !empty($csd_upload)) {
                                foreach ($csd_upload as $image) {
                                    if (isset($image->img_url) && !empty($image->img_url) && isset($image->img_id) && !empty($image->img_id)) {
                                        ?>
                                        <!-- <div class="clipart-img-wrap"> -->
                                            <!-- <span class="csd-del-img fa fa-close"></span> -->
                                        <span class="clipart-img" data-upload-id="<?php echo $image->img_id; ?>" data-url="<?php echo $image->img_url; ?>" data-img-name="<?php echo $image->img_name; ?>">
                                            <img src="<?php echo $image->img_url; ?>">  
                                        </span>
                                        <!-- </div> -->
                                        <?php
                                    }
                                }
                            } else {
                                ?>
                                <p><?php _e('No image found', 'csd'); ?></p>
                                <?php
                            }
                        } else {
                            global $current_user;
                            $current_user_id = $current_user->ID;
                            $user_uploads = isset(get_user_meta($current_user_id, 'csd_saved_uploads')[0]) ? get_user_meta($current_user_id, 'csd_saved_uploads')[0] : array();
                            if (is_array($user_uploads) && !empty($user_uploads)) {
                                $i = 0;
                                foreach ($user_uploads as $image) {
                                    if (isset($image['img_url']) && !empty($image['img_url']) && isset($image['img_id']) && !empty($image['img_id'])) {
                                        ?>
                                        <!-- <div class="clipart-img-wrap"> -->
                                        <!-- <button class="csd-del-img fa fa-close"></button> -->
                                        <span class="clipart-img" data-url="<?php echo $image['img_url']; ?>" data-img-name="<?php echo $image['img_name']; ?>" data-upload-id="<?php echo $image['img_id']; ?>">
                                            <img src="<?php echo $image['img_url']; ?>">
                                        </span>
                                        <!-- </div>    -->
                                        <?php
                                    }
                                }
                            } else {
                                ?>
                                <p><?php _e('No image found', 'csd'); ?></p>
                                <?php
                            }
                        }
                        ?>
                    </div>
                </div>
            </div>
        </div> 
        <div id="tab-social-facebook" class="csd-tab-content">
            <div class="csd-tab-content-wrapper">
                <div>
                    <div class="csd-rs-app">
                        <?php _e('Sign in to upload:', 'csd'); ?>
                        
                        <a class="csd-facebook acd-social-login" href="?social-login=facebook"><?php _e('Extract my pictures', 'csd'); ?></a>
                    </div>
                    <div class="csd-upload-search-wrap">
                        <span class="icon-464"></span>
                        <input id="csd-facebook-search"  placeholder="Search" type="text">
                    </div>
                    <div class="img-container">
                        <span class="clipart-img">
                            <img alt="image" id="5be08de62ecd2" src="<?php echo CSD_URL ?>includes/skins/default/assets/images/upload1.jpg">
                        </span>
                        <span class="clipart-img">
                            <img  alt="image" id="5be08de62ecd2" src="<?php echo CSD_URL ?>includes/skins/default/assets/images/upload2.jpg">

                        </span>
                        <span class="clipart-img">
                            <img alt="image" id="5be08de62ecd2" src="<?php echo CSD_URL ?>includes/skins/default/assets/images/upload3.jpg">
                        </span>
                        <span class="clipart-img">
                            <img alt="image" id="5be08de62ecd2" src="<?php echo CSD_URL ?>includes/skins/default/assets/images/upload4.jpg">
                        </span>
                    </div>
                </div>
            </div>
        </div>
        <div id="tab-social-instagram" class="csd-tab-content">
            <div class="csd-rs-app">
                <?php _e('Sign in to upload:', 'csd'); ?>
                <a class="csd-instagram acd-social-login" href="?social-login=instagram"><?php _e('Extract my pictures', 'csd'); ?></a>
            </div>
            <div class="csd-upload-search-wrap">
                <span class="icon-464"></span>
                <input id="csd-instagram-search"  placeholder="<?php echo esc_attr_e('Search', 'csd'); ?>" type="text">
            </div>
            <div class="img-container">
                <span class="clipart-img">
                    <img alt="image" id="5be08de62ecd2" src="<?php echo CSD_URL ?>includes/skins/default/assets/images/upload1.jpg">
                </span>
                <span class="clipart-img">
                    <img  alt="image" id="5be08de62ecd2" src="<?php echo CSD_URL ?>includes/skins/default/assets/images/upload2.jpg">

                </span>
                <span class="clipart-img">
                    <img alt="image" id="5be08de62ecd2" src="<?php echo CSD_URL ?>includes/skins/default/assets/images/upload3.jpg">
                </span>
                <span class="clipart-img">
                    <img alt="image" id="5be08de62ecd2" src="<?php echo CSD_URL ?>includes/skins/default/assets/images/upload4.jpg">
                </span>
            </div>
        </div>

        <?php
    }

    public function csd_summary() {
        ?>
        <div class="csd-tools-head" id="summary-panel">
            <div id="summary" class="icon-Asset-31"></div>
        </div>
        <div id="summary-panel-content" class="csd-tools-content">
            <div  class="csd-panel-head">
                <div class="csd-panel-title"><?php _e('Summary', 'csd'); ?></div>
                <span id="summary-panel-close" class="csd-tools-close fa fa-close"></span>
            </div>
            <div id="summary-accordions" class="" tabindex="0">
                <div class="csd-tab-content-wrapper">
                    <div>
                        <div class="csd-summary-bloc">
                            <div class="csd-summary-bloc-content">
                                <div class="csd-summary-bloc-title"><?php _e('Product name:', 'csd'); ?></div>
                                <div class="csd-summary-values">
                                    <?=$this->editor->csd_product->product->get_name();?>
                                </div>
                            </div>
                        </div>
                        <div class="csd-summary-bloc">
                            <div class="csd-summary-bloc-content">
                                <div class="csd-summary-bloc-title"><?php _e('Sign Size:', 'csd'); ?></div>
                                <div class="csd-summary-values">
                                    <span id="sumamary-width"></span> X <span id="sumamary-height"></span>
                                </div>
                            </div>
                        </div>
                        <!-- <div class="csd-summary-bloc">
                            <div class="csd-summary-bloc-content">
                                <div class="csd-summary-bloc-title"><?php _e('Options:', 'csd'); ?></div>
                                <div class="csd-summary-values">
                                    <div>Accessories</div>
                                    <div>None</div>
                                </div>
                            </div>
                            <div class="csd-summary-bloc-content">
                                <div class="csd-summary-bloc-title">Shape:</div>
                                <div class="csd-summary-values">
                                    <div>Square/Rectangle</div>
                                </div>
                            </div>
                        </div> -->
                        <div class="csd-summary-bloc">
                            <div class="csd-summary-bloc-content">
                                <div class="csd-summary-bloc-title"><?php _e('Quantity:', 'csd'); ?></div>
                                <div class="csd-summary-values" id = "summary-qty-values">
                                    1
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>

        </div>  
        <?php
    }

    public function csd_cart() {
        ?>
        <div class="csd-tools-head" id="add-cart-panel">
            <div id="add-cart-content" class="icon-shopping-cart"></div>
        </div>
        <div id="add-cart-panel-content" class="csd-tools-content">
            <div  class="csd-panel-head">
                <div class="csd-panel-title"><?php _e('Cart', 'csd'); ?></div>
                <span id="add-cart-panel-close" class="csd-tools-close fa fa-close"></span>
            </div>
            <div id="csd-cart-box" class="">                            
                <div class="csd-qty-container" data-id="36">
                    <div>
                        <input type="button" id="minus" value="-" class="csd-qty-minus csd-custom-right-quantity-input-set csd-btn-effect">
                        <input type="number" step="1" value="1" class="csd-custom-right-quantity-input csd-qty" min="1" max="" dntmesecondfocus="true" uprice="200">
                        <input type="button" id="plus" value="+" class="csd-qty-plus csd-custom-right-quantity-input-set csd-btn-effect">
                    </div>


                    <div class="total-price">
                        <span class="total_order">$500.00</span>
                    </div>
                    <!-- <p> 
                        <input type="checkbox" class="csd-validate-design" id="csd-validate-design" value="Design validated"> 
                        <?= _e('Validate the customization', 'csd');?>
                    </p> -->
                </div>
                <button id="csd_add_to_cart" class="csd-btn-effect" data-id="<?php echo esc_attr_e($this->editor->item_id); ?>"><?php _e('Add to cart', 'csd'); ?></button>
                <div id="debug-cart"> </div>
            </div>
        </div>
        <?php
    }

    public function csd_accessories() {
        ?>
        <div id='csd-option-bottom-wrap'>
            <div class='csd-option-wrap'>
                <div class="csd-custom-select-wrap">
                    <div class="csd-option-title">Accesories</div>
                    <div >
                        <div class="csd-custom-select-cover"></div>
                        <input type="text" name="csd-accessories" value="None" class="csd-custom-select" id="csd-accesories-select" readonly="">
                        <span class="csd-custom-select-icon icon-drop_arrow"></span>
                    </div>
                    <ul class="csd-custom-select-content hidden">
                        <li>None</li>
                        <li>option1</li>
                        <li>Option2</li>
                    </ul>
                </div>
                <div class="csd-custom-select-wrap">
                    <div class="csd-option-title">Shape</div>
                    <div >
                        <div class="csd-custom-select-cover"></div>
                        <input type="text" name="csd-shape" value="Inch" class="csd-custom-select" id="csd-shape-select" readonly="">
                        <span class="csd-custom-select-icon icon-drop_arrow"></span>
                    </div>
                    <ul class="csd-custom-select-content hidden">
                        <li>square</li>
                        <li>circle</li>
                        <li>option3</li>
                    </ul>
                </div>
                <div class="csd-custom-select-wrap">
                    <div class="csd-option-title">Shape</div>
                    <div>
                        <div class="csd-custom-select-cover"></div>
                        <input type="text" name="csd-unit" value="Inch" class="csd-custom-select" id="csd-unit-select" readonly="">
                        <span class="csd-custom-select-icon icon-drop_arrow"></span>
                    </div>
                    <ul class="csd-custom-select-content hidden">
                        <li>square</li>
                        <li>circle</li>
                        <li>option3</li>
                    </ul>
                </div>
                <div class="csd-custom-select-wrap">
                    <div class="csd-option-title">Shape</div>
                    <div >
                        <div class="csd-custom-select-cover"></div>
                        <input type="text" name="csd-unit" value="Inch" class="csd-custom-select" id="csd-unit-select" readonly="">
                        <span class="csd-custom-select-icon icon-drop_arrow"></span>
                    </div>
                    <ul class="csd-custom-select-content hidden">
                        <li>square</li>
                        <li>circle</li>
                        <li>option3</li>
                    </ul>
                </div>

            </div>
            <div class='csd-option-wrap'>
                <div class="csd-custom-select-wrap">
                    <div class="csd-option-title">Accesories</div>
                    <div >
                        <div class="csd-custom-select-cover"></div>
                        <input type="text" name="csd-unit" value="Inch" class="csd-custom-select" id="csd-unit-select" readonly="">
                        <span class="csd-custom-select-icon icon-drop_arrow"></span>
                    </div>
                    <ul class="csd-custom-select-content hidden">
                        <li>Inches</li>
                        <li>Cm</li>
                        <li>Feet</li>
                    </ul>
                </div>
            </div>

        </div>

        <?php
    }

    public function get_design_action() {
        global $csd_settings;

        $general_options = $csd_settings['csd-general-options'];

        if (isset($general_options['csd-download-btn'])) {
            $download_btn = $general_options['csd-download-btn'];
        }
        if (isset($general_options['csd-preview-btn'])) {
            $preview_btn = $general_options['csd-preview-btn'];
        }

        if (isset($preview_btn) && $preview_btn === '0' && isset($download_btn) && $download_btn === '0') {
            return;
        }
        ?>
        <?php if (isset($preview_btn) && $preview_btn !== 0) : ?>
            <span id="preview-btn" class="icon-491" data-placement="top" data-tooltip-title="<?php echo esc_attr_e('Preview', 'csd'); ?>"></span>
        <?php endif; ?>

        <?php if (isset($download_btn) && $download_btn !== 0) : ?>
            <span id="download-btn" class="icon-1166" data-placement="top" data-tooltip-title="<?php echo esc_attr_e('Download', 'csd'); ?>"></span>

        <?php endif; ?>

        <span id="save-btn" class="icon-612" data-placement="top" data-index="-1" data-tooltip-title="<?php echo esc_attr_e('Save', 'csd'); ?>"></span>
        <!-- <span id="shared-btn" class="icon-426" data-placement="top" data-index="-1" data-tooltip-title="<?php echo esc_attr_e('Share', 'csd'); ?>"></span>
        <div id="csd-share-tool" class="align_btn_wrap ">
            <div>
                <span id="csd-share-instagram" class="icon-social-media_icons-03" data-placement="top" data-tooltip-title="<?php echo esc_attr_e('Instagram', 'csd'); ?>"></span>
                <span id="csd-twitter-instagram" class="icon-social-media_icons-02" data-placement="top" data-tooltip-title="<?php echo esc_attr_e('Twitter', 'csd'); ?>"></span>
                <span id="csd-share-facebook" class="icon-social-media_icons-01" data-placement="top" data-tooltip-title="<?php echo esc_attr_e('Facebook', 'csd'); ?>"></span>

            </div>
        </div> -->
        <?php
        $modal = '<div class="omodal fade o-modal csd-modal" id="csd-modal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
            <div class="omodal-dialog">
              <div class="omodal-content">
                <div class="omodal-header">
                  <button type="button" class="close" data-dismiss="omodal" aria-hidden="true">&times;</button>
                  <h4 class="omodal-title" id="myModalLabel">' . __('PREVIEW', 'csd') . '</h4>
                </div>
                <div class="omodal-body txt-center">
                </div>
              </div>
            </div>
        </div>';
        echo $modal;
    }

    public function display() {

        $this->register_styles();
        $this->register_scripts();
        // phpinfo();
        // ob_start();
        ?>

        <div class="csd-container csd-porto-skin csd-responsive-mode">      
            <div class="csd-editor-wrap ">
                <div class="csd-editor-col csd-editor-col-tools is-open">
                    <div class="csd-tools-container">     
                        <div class="csd-tools-wrap">
                            <div class="csd-tools-head" id="text-panel">
                                <div id="text" class="icon-typography"></div>
                            </div>
                            <div id="text-panel-content" class="csd-tools-content">
                                <?php $this->text_panel_content() ?>
                                <div class="text-tool-container dspl-table">
                                    <?php $this->tab_formating(); ?>
                                    <div id="tab-font" class="csd-tab-content">
                                        <?php $this->content_font_family() ?>
                                    </div>
                                    <div id="tab-text-style" class="csd-tab-content">
                                        <?php $this->csd_text_style() ?>
                                    </div>
                                </div>          
                            </div>
                        </div>
                        <div class="csd-tools-wrap">
                            <div class="csd-tools-head" id="cliparts-panel">
                                <div id="cliparts" class="icon-smile"></div>
                            </div>
                            <?php $this->cliparts_content() ?>
                        </div>
                        <?php apply_filters("add-scoth-cj-display-scotch-section", $this->wpc_metas); ?>
                        <div class="csd-tools-wrap">
                            <div class="csd-tools-head" id="uploads-panel">
                                <div id="uploads" class="icon-Asset-21"></div>
                            </div>
                            <div id="uploads-panel-content" class="csd-tools-content">
                                <?php $this->upload_image() ?>
                            </div>
                        </div>
                        <div class="csd-tools-wrap">
                            <?php $this->csd_summary() ?>
                        </div>                          
                        <div class="csd-tools-wrap">
                            <?php $this->csd_cart() ?>
                        </div>
                        <div class="csd-tools-wrap">

                            <div id="csd-filters-tools-wrap" class="csd-tools-content">
                                <?php echo $this->csd_get_filters_tools(); ?>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="csd-editor-col-2">
                    <div class="container">
                        <div id="tab-customize" class="csd-tab-content-main current">
                            <?php $this->tools_header() ?>
                            <div id="csd-editor-container">
                                <span>
                                    <div class="csd-button-bar-wrap">
                                        <div class="csd-button-bar">
                                            <span id="copy_paste_btn" class="icon-443 csd_btn_hidden" data-placement="top" data-tooltip-title="<?php echo esc_attr_e('Duplicate', 'csd'); ?>"></span>
                                            <span id="align_btn" class="icon-683 csd_btn_hidden" data-placement="top" data-tooltip-title="<?php echo esc_attr_e('Alignments', 'csd'); ?>"></span>
                                            <div id="csd-align-tool" class="align_btn_wrap">
                                                <div>
                                                    <span id="send_to_back_btn" class="icon-677" data-placement="bottom" data-tooltip-title="<?php echo esc_attr_e('Send to back', 'csd'); ?>"></span>
                                                    <span id="bring_to_front_btn" class="icon-676" data-placement="bottom" data-tooltip-title="<?php echo esc_attr_e('Bring to front', 'csd'); ?>"></span>
                                                    <span id="flip_h_btn" class="icon-687" data-placement="bottom" data-tooltip-title="<?php echo esc_attr_e('Flip horizontally', 'csd'); ?>"></span>
                                                    <span id="flip_v_btn" class="icon-691" data-placement="top" data-tooltip-title="<?php echo esc_attr_e('Flip vertically', 'csd'); ?>"></span>
                                                    <span id="align_h_btn" class="icon-680" data-placement="top" data-tooltip-title="<?php echo esc_attr_e('Center horizontally', 'csd'); ?>"></span>
                                                    <span id="align_v_btn" class="icon-682" data-placement="top" data-tooltip-title="<?php echo esc_attr_e('Center vertically', 'csd'); ?>"></span>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="csd-button-bar">
                                            <span id="clear_all_btn" class="icon-1407 csd_btn_hidden" data-placement="top" data-tooltip-title="<?php echo esc_attr_e('Clear all', 'csd'); ?>"></span>
                                            <span id="delete_btn" class="icon-014 csd_btn_hidden" data-placement="top" data-tooltip-title="<?php echo esc_attr_e('Delete', 'csd'); ?>"></span>
                                        </div>
                                        <?php
                                        $product_part_container = '<div id="product-part-container" class="hidden">
                                            <ul id="csd-parts-bar">
                                                <li data-id="Signs_Design" data-url="" data-bg="" class="active first " data-placement="top" data-tooltip-title="<?php echo esc_attr_e("Signs_Design", "csd"); ?>" data-ov="" data-ovni="-1" class="last" >
                                                </li>
                                            </ul>
                                        </div>';
                                        echo apply_filters("add-scoth-cj-get-part-section", $product_part_container, $this->wpc_metas);
                                        ?>
                                    </div>
                                </span>
                                <div class="csd-editor-content">

                                    <canvas id="csd-editor"></canvas>

                                </div>
                                <span class="csd-editor-right-tools-wrap">
                                    <div class="csd-button-bar-wrap">
                                        <div class="csd-button-bar">
                                            <span id="undo-btn" class="icon-csd_icons-09 disabled" data-placement="top" data-tooltip-title="<?php echo esc_attr_e('Undo', 'csd'); ?>"></span>
                                            <span id="redo-btn" class="icon-csd_icons-08 disabled" data-placement="top" data-tooltip-title="<?php echo esc_attr_e('Redo', 'csd'); ?>"></span>
                                        </div>

                                        <div class="csd-button-bar">
                                            <div class="total-price">
                                                <span class="total_order">$500.00</span>
                                            </div>

                                        </div>
                                        <div class="csd-button-bar">
                                            <?php $this->get_design_action(); ?>
                                        </div>
                                    </div>
                                </span>
                            </div>
                            <?php // $this->csd_accessories()?>
                        </div>                 
                        <div id="debug-wrap"><div id="debug"></div><div class="debug-icon"></div></div>  
                        <?php
                        if (class_exists('Ofb')) {
                            if (isset($this->wpc_metas['form-builder'])) {
                                if ($this->wpc_metas['form-builder'] != '') {
                                    echo display_form_builder($this->wpc_metas['form-builder']);
                                }
                            }
                        }
                        ?>
                    </div>

                </div>
            </div>
        </div>




        <?php
        //$output = ob_get_clean();
        //return $output;
    }

    private function csd_get_filters_tools() {
        ?>
        <div class="csd-uploads-editing-wrap">
            <div id="csd-uploads-filters-wrap" class="">
                <div  class="csd-panel-head">
                    <span ><?php _e('Edit Clipart', 'csd'); ?></span>
                    <div class="csd-clipart-edit-close icon-557"></div>
                </div>
                <div  class="">
                    <div class="filter-set-container">
                        <span><?php _e('Filters', 'csd'); ?></span>
                        <div class="txt-center ">
                            <input type="checkbox" id="grayscale-1" class="custom-cb filter-cb acd-grayscale">
                            <label for="grayscale-1"><?php _e('Grayscale', 'csd'); ?></label>
                            <input type="checkbox" id="invert-1" class="custom-cb filter-cb acd-invert">
                            <label for="invert-1"><?php _e('Invert', 'csd'); ?></label>
                            <input type="checkbox" id="sepia-1" class="custom-cb filter-cb acd-sepia">
                            <label for="sepia-1"><?php _e('Sepia 1', 'csd'); ?></label>
                            <input type="checkbox" id="blur-1" class="custom-cb filter-cb acd-blur">
                            <label for="blur-1"><?php _e('Blur', 'csd'); ?></label>
                            <input type="checkbox" id="sharpen-1" class="custom-cb filter-cb acd-sharpen">
                            <label for="sharpen-1"><?php _e('Sharpen', 'csd'); ?></label>
                            <input type="checkbox" id="emboss-1" class="custom-cb filter-cb acd-emboss">
                            <label for="emboss-1"><?php _e('Emboss', 'csd'); ?></label>
                            <div class="clipart-bg-color-container"></div>
                        </div>
                    </div>
                    <div class="csd-tool-row">
                        <span><?php _e('Opacity', 'csd'); ?></span>
                        <div>  
                            <div class="csd-number-input">
                                <button class="minus" ></button>
                                <input class="quantity" name="opacity"  id="txt-opacity-slider" data-opacity="true" step="0.1" min="0" max="1" value="1" type="number">
                                <button  class="plus"></button>
                            </div> 
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <?php
    }

    private function register_scripts() {
        wp_enqueue_script('csd-js', CSD_URL . 'includes/skins/default/assets/js/csd.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-accounting-js', CSD_URL . 'includes/skins/default/assets/js/accounting.min.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-colorpicker-js', CSD_URL . 'includes/skins/default/assets/js/colorpicker.min.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-editor-img-js', CSD_URL . 'includes/skins/default/assets/js/editor.img2.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-editor-js', CSD_URL . 'includes/skins/default/assets/js/editor2.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-editor-text-js', CSD_URL . 'includes/skins/default/assets/js/editor.text2.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-editor-toolbar-js', CSD_URL . 'includes/skins/default/assets/js/editor.toolbar2.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-fabric-js', CSD_URL . 'includes/skins/default/assets/js/fabric.all.min2.js', array(), CSD_VERSION, false);

        wp_enqueue_script('csd-jquery-form-js', CSD_URL . 'includes/skins/default/assets/js/jquery.form.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-jquery-lazyload-js', CSD_URL . 'includes/skins/default/assets/js/jquery.lazyload.min.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-jquery-mCustomScrollbar-js', CSD_URL . 'includes/skins/default/assets/js/jquery.mCustomScrollbar.min.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-jquery-number-js', CSD_URL . 'includes/skins/default/assets/js/jquery.number.min.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-jquery-qtip-js', CSD_URL . 'includes/skins/default/assets/js/jquery.qtip-1.0.0-rc3.min.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-jquery-serializejson-js', CSD_URL . 'includes/skins/default/assets/js/jquery.serializejson.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-lodash-js', CSD_URL . 'includes/skins/default/assets/js/lodash.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-scrollevent-js', CSD_URL . 'includes/skins/default/assets/js/scrollevent.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-spectrum-js', CSD_URL . 'includes/skins/default/assets/js/spectrum.min.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-tooltip-js', CSD_URL . 'includes/skins/default/assets/js/tooltip.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-wp-js-hooks-js', CSD_URL . 'includes/skins/default/assets/js/wp-js-hooks.min.js', array(), CSD_VERSION, false);

        wp_enqueue_script('csd-SpryAccordion-js', CSD_URL . 'includes/skins/default/assets/js/SpryAssets/SpryAccordion.min.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-jquery-blockUI-js', CSD_URL . 'includes/skins/default/assets/js/blockUI/jquery.blockUI.min.js', array(), CSD_VERSION, false);
        /*        wp_enqueue_script( 'csd-modal-js', CSD_URL . 'includes/skins/default/assets/js/modal/modal.min.js', array(), CSD_VERSION, false ); */
        wp_enqueue_script('csd-jquery-ui-widget-js', CSD_URL . 'includes/skins/default/assets/js/upload/js/jquery.ui.widget.min.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-jquery-fileupload-js', CSD_URL . 'includes/skins/default/assets/js/upload/js/jquery.fileupload.min.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-jquery-iframe-transport-js', CSD_URL . 'includes/skins/default/assets/js/upload/js/jquery.iframe-transport.min.js', array(), CSD_VERSION, false);
        wp_enqueue_script('csd-jquery-knob-js', CSD_URL . 'includes/skins/default/assets/js/upload/js/jquery.knob.min.js', array(), CSD_VERSION, false);
        apply_filters("csd-register-scripts-filter", true);
        csd_register_scripts();
    }

    private function register_styles() {
        wp_enqueue_style('csd-css', CSD_URL . 'includes/skins/default/assets/css/csd.css', array(), CSD_VERSION, 'all');
        wp_enqueue_style('csd-line-icons-css', CSD_URL . 'includes/skins/default/assets/css/line-icons.css', array(), CSD_VERSION, 'all');
        wp_enqueue_style('csd-icons-css', CSD_URL . 'includes/skins/default/assets/css/csd_icons.css', array(), CSD_VERSION, 'all');
        wp_enqueue_style('csd-colorpicker-css', CSD_URL . 'includes/skins/default/assets/css/colorpicker.min.css', array(), CSD_VERSION, 'all');
        wp_enqueue_style('csd-font-awesome-css', CSD_URL . 'includes/skins/default/assets/css/font-awesome.min.css', array(), CSD_VERSION, 'all');
        wp_enqueue_style('csd-jquery-mCustomScrollbar-css', CSD_URL . 'includes/skins/default/assets/css/jquery.mCustomScrollbar.min.css', array(), CSD_VERSION, 'all');
        /* wp_enqueue_style( 'csd-modal-css', CSD_URL . 'includes/skins/default/assets/css/modal.min.css', array(), CSD_VERSION, 'all' ); */
        wp_enqueue_style('csd-spectrum-css', CSD_URL . 'includes/skins/default/assets/css/spectrum.min.css', array(), CSD_VERSION, 'all');
        //wp_enqueue_style( 'csd-style-css', CSD_URL . 'includes/skins/default/assets/css/style.css', array(), CSD_VERSION, 'all' );
        wp_enqueue_style('csd-tooltip-css', CSD_URL . 'includes/skins/default/assets/css/tooltip.min.css', array(), CSD_VERSION, 'all');
        apply_filters("csd-register-styles-filter", true);
        csd_register_fonts($this->wpc_metas);
    }

}
